## this spmath script is a suite of tests for the iterative solvers 
## available in spmath/sparskit. 
A = fdmat(30,30,1,[0 0 0 0 0 0 ]);
n = nrow(A); 
e = ones(n,1) ;
rhs = A*e;
guess = rand(n,1,1); 
solve(A, rhs,guess);

## first GMRES(30) with various preconditioners. 

slvr_solver_name = "gmres"
slvr_prec_type = "right"
slvr_krylov = 30
slvr_maxmult = 100 
slvr_tols = [0.000001, 0.0]

###"Solution with ILUT" 

slvr_prec_name="ilut";
slvr_prec_args=[10, 0.001]
x = solve(A, rhs,guess);
x(1:10) 


###"Solution with ILU0" 

slvr_prec_name="ilu0";
slvr_prec_args=[0]
x = solve(A, rhs,guess);
x(1:10) 

## "Solution with ILU(2)"
slvr_prec_name="iluk"
slvr_prec_args=[2];
x = solve(A, rhs,guess);
x(1:10) 

## "Solution with ILUD"
slvr_prec_name="ilud" 
slvr_prec_args=[1.0, 0.05] ;
x = solve(A, rhs,guess);
x(1:10) 

## now fix preconditioner (ILU(20,0.005) and use various
## accelerators. 

## "Solution with ILUT-bcgstab"
slvr_prec_name="ilut";
slvr_prec_args=[20, 0.0005] ;
slvr_solver_name="bcgstab";
x = solve(A, rhs,guess);
x(1:10) 

## "Solution with ILUT-tfqmr" 
slvr_prec_name="ilut";
slvr_prec_args=[20, 0.0005] ;
slvr_solver_name="tfqmr";
x = solve(A, rhs,guess);
x(1:10) 


