
/*  A Bison parser, made from spmath.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	SEMI	257
#define	COMMA	258
#define	ASSIGN	259
#define	OR	260
#define	AND	261
#define	LT	262
#define	LE	263
#define	EQ	264
#define	GE	265
#define	GT	266
#define	NE	267
#define	COLON	268
#define	PLUS	269
#define	MINUS	270
#define	MULT	271
#define	EMULT	272
#define	DIV	273
#define	EDIV	274
#define	LDIV	275
#define	ELDIV	276
#define	TRANSP	277
#define	UPLUS	278
#define	UMINUS	279
#define	INC	280
#define	DEC	281
#define	NOT	282
#define	POW	283
#define	EPOW	284
#define	ERROR	285
#define	TYPE	286
#define	WHO	287
#define	WHOS	288
#define	BREAK	289
#define	CONTINUE	290
#define	ELSE	291
#define	ELSEIF	292
#define	END	293
#define	ENDFOR	294
#define	ENDFUNCTION	295
#define	ENDIF	296
#define	ENDWHILE	297
#define	FOR	298
#define	FUNCTION	299
#define	GLOBAL	300
#define	IF	301
#define	RETURN	302
#define	WHILE	303
#define	HISTORY	304
#define	HIST_LIST	305
#define	LOAD	306
#define	DEMO	307
#define	READMT	308
#define	GEN57PT	309
#define	SUBMAT	310
#define	EXTRACT	311
#define	EXTRACT_COL	312
#define	EXTRACT_ROW	313
#define	FILTER	314
#define	CSORT	315
#define	RMDIA	316
#define	GETDIA	317
#define	GETU	318
#define	GETL	319
#define	GETBWD	320
#define	GETBWDU	321
#define	GETBWDL	322
#define	BLKFND	323
#define	CNRMS	324
#define	ROSCAL	325
#define	COSCAL	326
#define	ADDBLK	327
#define	GET1UP	328
#define	PRTMT	329
#define	RPERM	330
#define	CPERM	331
#define	DPERM	332
#define	HELP	333
#define	SOLVE_SYSTEM	334
#define	MULTIC	335
#define	COLORS	336
#define	COLORS2	337
#define	COLORSET	338
#define	INDSET0	339
#define	INDSET1	340
#define	SPY	341
#define	SQRT	342
#define	COS	343
#define	SIN	344
#define	TAN	345
#define	COT	346
#define	SC	347
#define	CSC	348
#define	ARCCOS	349
#define	ARCSIN	350
#define	ARCTAN	351
#define	ARCCOT	352
#define	ARCSEC	353
#define	ARCCSC	354
#define	ABS	355
#define	EXP	356
#define	LOG	357
#define	LOG10	358
#define	RND	359
#define	IRND	360
#define	CEIL	361
#define	FLOOR	362
#define	ROUND	363
#define	TRUNC	364
#define	NCOL	365
#define	NROW	366
#define	NNZ	367
#define	SIZE2	368
#define	EYE	369
#define	ZEROS	370
#define	SPZEROS	371
#define	ONES	372
#define	INIT	373
#define	INPUT	374
#define	CLEAR	375
#define	DENSIFY	376
#define	SPARSIFY	377
#define	ISDENSE	378
#define	ISNUMBER	379
#define	ISSPARSE	380
#define	ISSTRING	381
#define	ISVECTOR	382
#define	WHAT_IS	383
#define	ALIAS	384
#define	NAME	385
#define	NUMBER	386
#define	STR	387
#define	BODY	388
#define	CATCH	389
#define	SYSTEM	390

#line 1 "spmath.y"
 

//////////////////////////////////////////////////////////
//
// spmath.y
// ~~~~~~~~
//
//  This is the yacc grammar file for spmath.  It contains
// the definition of spmath's grammar, as well as some
// important utility functions for loading, parsing, and
// saving spmath commands and files.  There are also a few
// utility math functions.
//
//  The first section ,everything from the beginning of the
// file to the first "%%", contains definitions and 
// prototypes.  It is also where all the lex tokens and
// precedence rules are set.  
//
//  The second section, everything from the first "%%" to
// the second "%%", contains the actual grammar.  
// Basically, this consists of a context free grammar in
// a variation of backus-naur form.  The rules have the
// form
//
// Variable: (Variables + tokens)
//         | (Variables + tokens)
//         | (Variables + tokens)
//         etc...
//         ;
//
// Note that each rule has a "if(text_flag)" section and
// then an "else" section.  This is because when text_flag
// is true, the parser is in the process of parsing a 
// user-defined function's body, which is being turned 
// into text so it can be parsed later when it is called 
// by the user.  When text_flag is false, the command is
// simply being executed.
//
// See a good lex/yacc book for more info on grammars,
// and also look at README_MODIFICATION.  Also, see 
// functions.C for the definitions of many of the 
// fucntions called from these grammar rules.
//
//  The third section, everything from the second "%%" to
// the end of the file, contains some C function 
// definitions.  Everything between the "%{" and "%}"
// symbols is copied verbatim into the output C file.
//
//////////////////////////////////////////////////////////

#include <stdlib.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <assert.h>
#include "spmath.h"

  // Size of the input buffer

#define BUFF_SIZE 8*1024

  // A helpful yacc define

#define YYERROR_VERBOSE

  // A few helpful lex defines

#define CATCH_MODE 1
#define VECTOR_MODE 2

int yyerror(char *);
int yyerror(const char *);
int yyparse();
int sp_parse(char *input);
int sp_parse_string(const char *);
value * load (value *, int, int &);
value * save (value *, value *, int &);
value * eval_funct (char *, list *, int &);
value * process_comma_list (list *, int &);
value * process_dense_row_list (list *, int &);

// These are defined to be extern "C" so they can be
// passed as "ffunc"s to the "function" function in
// functions.C

extern "C" {
  double cot (double);
  double csc (double);
  double sec (double);
  double acot (double);
  double acsc (double);
  double asec (double);
  double round (double);
  double trunc (double);
  double rnd (double);
}

symtab root, alia;
symtab *syms = &root;
int hist_num = 1; 
int hist_cur = 1;

// The global history list
history hist_list (100);

// global variables for using a string for input to the lexer.
char *str;
int lk;
int clear_alias = 0;   // Allow to remove an alias!
int several_init = 0;  // 1 when the arguments of a function are in fact output
int str_flag = 0;
symtab *ali = &alia;
int text_flag = 0;
int nest_count = 0;
 int supress_output = 0;
int err = 0;

extern FILE *yyin;
extern void yyrestart (FILE *);
extern void my_yybegin(int);

// The list of view for visualization in tk mode

#ifndef NO_TK_COMPILE

view *spyviews[MAX_VIEWS];
int cur_spyview;

#endif


#line 138 "spmath.y"
typedef union {
  char *name;
  value *val;
  list *set;
} YYSTYPE;
#line 144 "spmath.y"


extern int yy_start;
extern int yylex(YYSTYPE *);

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		606
#define	YYFLAG		-32768
#define	YYNTBASE	141

#define YYTRANSLATE(x) ((unsigned)(x) <= 390 ? yytranslate[x] : 179)

static const short yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,   137,
   138,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
   139,     2,   140,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
   107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
   127,   128,   129,   130,   131,   132,   133,   134,   135,   136
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     8,    12,    16,    18,    20,    22,    25,    27,
    29,    31,    33,    34,    36,    38,    40,    42,    44,    45,
    46,    58,    59,    60,    71,    72,    73,    74,    75,    76,
    89,    90,   101,   102,   117,   118,   119,   120,   135,   136,
   137,   138,   155,   159,   166,   173,   182,   186,   190,   194,
   198,   202,   206,   210,   214,   218,   222,   226,   230,   234,
   238,   242,   246,   249,   252,   255,   258,   261,   264,   267,
   270,   274,   278,   282,   284,   286,   288,   290,   292,   293,
   300,   301,   307,   308,   315,   316,   323,   328,   329,   333,
   338,   343,   348,   353,   358,   363,   370,   375,   382,   387,
   394,   403,   408,   411,   416,   429,   438,   445,   452,   463,
   470,   477,   484,   489,   494,   499,   504,   509,   514,   521,
   528,   535,   540,   551,   562,   585,   594,   599,   604,   613,
   618,   623,   628,   635,   642,   649,   658,   663,   668,   673,
   678,   683,   688,   693,   698,   703,   708,   713,   718,   723,
   728,   733,   738,   743,   748,   753,   758,   763,   768,   777,
   788,   792,   797,   802,   807,   812,   817,   822,   827,   832,
   837,   842,   847,   851,   853,   856,   858,   861,   863,   867,
   869,   875,   876
};

static const short yyrhs[] = {   164,
     3,   141,     0,   164,     4,   141,     0,   142,     3,   141,
     0,   142,     4,   141,     0,   164,     0,   142,     0,   136,
     0,    50,   164,     0,    51,     0,   130,     0,    33,     0,
    34,     0,     0,     1,     0,   157,     0,   154,     0,   148,
     0,   143,     0,     0,     0,    45,   131,     5,   131,   137,
   144,   175,   138,   141,   145,    39,     0,     0,     0,    45,
   131,     5,   131,   137,   146,   138,   141,   147,    39,     0,
     0,     0,     0,     0,     0,    49,   137,   149,   164,   150,
   138,   151,   141,   152,    39,   153,   135,     0,     0,    47,
   137,   164,   177,   138,   141,   178,    39,   155,   135,     0,
     0,    47,   137,   164,   177,   138,   141,   178,    37,   177,
   141,   178,    39,   156,   135,     0,     0,     0,     0,    44,
   137,   131,     5,   164,    14,   164,   158,   138,   141,   159,
    39,   160,   135,     0,     0,     0,     0,    44,   137,   131,
     5,   164,    14,   164,    14,   164,   161,   138,   141,   162,
    39,   163,   135,     0,   131,     5,   164,     0,   131,   137,
   175,   138,     5,   164,     0,   131,   137,   164,    14,   164,
   138,     0,   131,   137,   164,    14,   164,    14,   164,   138,
     0,   164,     6,   164,     0,   164,     7,   164,     0,   164,
     8,   164,     0,   164,     9,   164,     0,   164,    10,   164,
     0,   164,    11,   164,     0,   164,    12,   164,     0,   164,
    13,   164,     0,   164,    15,   164,     0,   164,    16,   164,
     0,   164,    17,   164,     0,   164,    18,   164,     0,   164,
    19,   164,     0,   164,    20,   164,     0,   164,    21,   164,
     0,   164,    22,   164,     0,   164,    23,     0,    15,   164,
     0,    16,   164,     0,    26,   131,     0,   131,    26,     0,
    27,   131,     0,   131,    27,     0,    28,   164,     0,   164,
    29,   164,     0,   164,    30,   164,     0,   137,   164,   138,
     0,   131,     0,   132,     0,   133,     0,   171,     0,   165,
     0,     0,   131,   137,   175,   138,   166,   135,     0,     0,
   131,   137,   138,   167,   135,     0,     0,    52,   137,   164,
   138,   168,   135,     0,     0,    53,   137,   164,   138,   169,
   135,     0,   130,   131,     5,   164,     0,     0,    79,   170,
   135,     0,   112,   137,   164,   138,     0,   111,   137,   164,
   138,     0,   113,   137,   164,   138,     0,   114,   137,   164,
   138,     0,   115,   137,   164,   138,     0,   117,   137,   164,
   138,     0,   117,   137,   164,     4,   164,   138,     0,   116,
   137,   164,   138,     0,   116,   137,   164,     4,   164,   138,
     0,   118,   137,   164,   138,     0,   118,   137,   164,     4,
   164,   138,     0,   119,   137,   164,     4,   164,     4,   164,
   138,     0,   121,   137,   131,   138,     0,   121,   131,     0,
    54,   137,   164,   138,     0,    56,   137,   164,     4,   164,
     4,   164,     4,   164,     4,   164,   138,     0,    57,   137,
   164,     4,   164,     4,   164,   138,     0,    59,   137,   164,
     4,   164,   138,     0,    58,   137,   164,     4,   164,   138,
     0,    60,   137,   164,     4,   164,     4,   164,     4,   164,
   138,     0,    61,   137,   164,     4,   164,   138,     0,    62,
   137,   164,     4,   164,   138,     0,    63,   137,   164,     4,
   164,   138,     0,    64,   137,   164,   138,     0,    65,   137,
   164,   138,     0,    66,   137,   164,   138,     0,    67,   137,
   164,   138,     0,    68,   137,   164,   138,     0,    69,   137,
   164,   138,     0,    70,   137,   164,     4,   164,   138,     0,
    72,   137,   164,     4,   164,   138,     0,    71,   137,   164,
     4,   164,   138,     0,    74,   137,   164,   138,     0,    73,
   137,   164,     4,   164,     4,   164,     4,   164,   138,     0,
    55,   137,   164,     4,   164,     4,   164,     4,   164,   138,
     0,    80,   137,   164,     4,   164,     4,   164,     4,   164,
     4,   164,     4,   164,     4,   164,     4,   164,     4,   164,
     4,   164,   138,     0,    80,   137,   164,     4,   164,     4,
   164,   138,     0,    81,   137,   164,   138,     0,    82,   137,
   164,   138,     0,    84,   137,   164,     4,   131,     4,   131,
   138,     0,    85,   137,   164,   138,     0,    86,   137,   164,
   138,     0,    83,   137,   164,   138,     0,    75,   137,   164,
     4,   164,   138,     0,    76,   137,   164,     4,   164,   138,
     0,    77,   137,   164,     4,   164,   138,     0,    78,   137,
   164,     4,   164,     4,   164,   138,     0,    90,   137,   164,
   138,     0,    88,   137,   164,   138,     0,    89,   137,   164,
   138,     0,    91,   137,   164,   138,     0,    92,   137,   164,
   138,     0,    93,   137,   164,   138,     0,    94,   137,   164,
   138,     0,    96,   137,   164,   138,     0,    95,   137,   164,
   138,     0,    97,   137,   164,   138,     0,    98,   137,   164,
   138,     0,    99,   137,   164,   138,     0,   100,   137,   164,
   138,     0,   102,   137,   164,   138,     0,   103,   137,   164,
   138,     0,   104,   137,   164,   138,     0,   101,   137,   164,
   138,     0,   107,   137,   164,   138,     0,   108,   137,   164,
   138,     0,   109,   137,   164,   138,     0,   110,   137,   164,
   138,     0,   105,   137,   164,   138,     0,   105,   137,   164,
     4,   164,     4,   164,   138,     0,   105,   137,   164,     4,
   164,     4,   164,     4,   164,   138,     0,   105,   137,   138,
     0,   106,   137,   164,   138,     0,   122,   137,   164,   138,
     0,   123,   137,   164,   138,     0,   125,   137,   164,   138,
     0,   124,   137,   164,   138,     0,   126,   137,   164,   138,
     0,   127,   137,   164,   138,     0,   128,   137,   164,   138,
     0,   129,   137,   164,   138,     0,    32,   137,   164,   138,
     0,    87,   137,   164,   138,     0,   139,   172,   140,     0,
   176,     0,   173,   172,     0,   174,     0,   175,     3,     0,
   175,     0,   164,     4,   175,     0,   164,     0,   164,    14,
   164,    14,   164,     0,     0,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   327,   345,   365,   383,   403,   414,   427,   436,   456,   468,
   480,   492,   502,   507,   517,   524,   531,   538,   549,   551,
   553,   612,   614,   616,   646,   648,   650,   652,   654,   659,
   717,   720,   761,   764,   823,   825,   827,   830,   887,   889,
   891,   894,   961,   994,  1049,  1077,  1108,  1134,  1160,  1186,
  1212,  1238,  1264,  1290,  1316,  1342,  1368,  1394,  1420,  1446,
  1474,  1474,  1474,  1496,  1505,  1526,  1555,  1597,  1626,  1668,
  1688,  1714,  1741,  1757,  1785,  1792,  1805,  1812,  1822,  1832,
  1982,  1988,  2035,  2041,  2068,  2074,  2101,  2127,  2134,  2143,
  2165,  2187,  2209,  2247,  2269,  2290,  2318,  2339,  2367,  2388,
  2416,  2450,  2469,  2488,  2512,  2560,  2601,  2636,  2676,  2718,
  2746,  2774,  2802,  2822,  2842,  2862,  2882,  2902,  2923,  2951,
  2979,  3007,  3027,  3073,  3114,  3197,  3235,  3255,  3275,  3331,
  3351,  3372,  3397,  3424,  3451,  3478,  3513,  3535,  3557,  3579,
  3601,  3623,  3645,  3667,  3689,  3711,  3733,  3755,  3777,  3799,
  3821,  3843,  3865,  3887,  3909,  3931,  3953,  3975,  3997,  4033,
  4076,  4086,  4099,  4125,  4154,  4172,  4190,  4208,  4226,  4249,
  4317,  4330,  4392,  4422,  4429,  4435,  4443,  4475,  4508,  4514,
  4523,  4560,  4567
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","SEMI","COMMA",
"ASSIGN","OR","AND","LT","LE","EQ","GE","GT","NE","COLON","PLUS","MINUS","MULT",
"EMULT","DIV","EDIV","LDIV","ELDIV","TRANSP","UPLUS","UMINUS","INC","DEC","NOT",
"POW","EPOW","ERROR","TYPE","WHO","WHOS","BREAK","CONTINUE","ELSE","ELSEIF",
"END","ENDFOR","ENDFUNCTION","ENDIF","ENDWHILE","FOR","FUNCTION","GLOBAL","IF",
"RETURN","WHILE","HISTORY","HIST_LIST","LOAD","DEMO","READMT","GEN57PT","SUBMAT",
"EXTRACT","EXTRACT_COL","EXTRACT_ROW","FILTER","CSORT","RMDIA","GETDIA","GETU",
"GETL","GETBWD","GETBWDU","GETBWDL","BLKFND","CNRMS","ROSCAL","COSCAL","ADDBLK",
"GET1UP","PRTMT","RPERM","CPERM","DPERM","HELP","SOLVE_SYSTEM","MULTIC","COLORS",
"COLORS2","COLORSET","INDSET0","INDSET1","SPY","SQRT","COS","SIN","TAN","COT",
"SC","CSC","ARCCOS","ARCSIN","ARCTAN","ARCCOT","ARCSEC","ARCCSC","ABS","EXP",
"LOG","LOG10","RND","IRND","CEIL","FLOOR","ROUND","TRUNC","NCOL","NROW","NNZ",
"SIZE2","EYE","ZEROS","SPZEROS","ONES","INIT","INPUT","CLEAR","DENSIFY","SPARSIFY",
"ISDENSE","ISNUMBER","ISSPARSE","ISSTRING","ISVECTOR","WHAT_IS","ALIAS","NAME",
"NUMBER","STR","BODY","CATCH","SYSTEM","'('","')'","'['","']'","statement","control_statement",
"function_definition","@1","@2","@3","@4","while_statement","@5","@6","@7","@8",
"@9","if_statement","@10","@11","for_statement","@12","@13","@14","@15","@16",
"@17","expression","function_call","@18","@19","@20","@21","@22","dense","dense_row_list",
"dense_row","dense_row_end","comma_list","vector","subroutin_inc","subroutin_dec", NULL
};
#endif

static const short yyr1[] = {     0,
   141,   141,   141,   141,   141,   141,   141,   141,   141,   141,
   141,   141,   141,   141,   142,   142,   142,   142,   144,   145,
   143,   146,   147,   143,   149,   150,   151,   152,   153,   148,
   155,   154,   156,   154,   158,   159,   160,   157,   161,   162,
   163,   157,   164,   164,   164,   164,   164,   164,   164,   164,
   164,   164,   164,   164,   164,   164,   164,   164,   164,   164,
   164,   164,   164,   164,   164,   164,   164,   164,   164,   164,
   164,   164,   164,   164,   164,   164,   164,   164,   166,   165,
   167,   165,   168,   165,   169,   165,   165,   170,   165,   165,
   165,   165,   165,   165,   165,   165,   165,   165,   165,   165,
   165,   165,   165,   165,   165,   165,   165,   165,   165,   165,
   165,   165,   165,   165,   165,   165,   165,   165,   165,   165,
   165,   165,   165,   165,   165,   165,   165,   165,   165,   165,
   165,   165,   165,   165,   165,   165,   165,   165,   165,   165,
   165,   165,   165,   165,   165,   165,   165,   165,   165,   165,
   165,   165,   165,   165,   165,   165,   165,   165,   165,   165,
   165,   165,   165,   165,   165,   165,   165,   165,   165,   165,
   165,   165,   171,   171,   172,   172,   173,   174,   175,   175,
   176,   177,   178
};

static const short yyr2[] = {     0,
     3,     3,     3,     3,     1,     1,     1,     2,     1,     1,
     1,     1,     0,     1,     1,     1,     1,     1,     0,     0,
    11,     0,     0,    10,     0,     0,     0,     0,     0,    12,
     0,    10,     0,    14,     0,     0,     0,    14,     0,     0,
     0,    16,     3,     6,     6,     8,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     2,     2,     2,     2,     2,     2,     2,     2,
     3,     3,     3,     1,     1,     1,     1,     1,     0,     6,
     0,     5,     0,     6,     0,     6,     4,     0,     3,     4,
     4,     4,     4,     4,     4,     6,     4,     6,     4,     6,
     8,     4,     2,     4,    12,     8,     6,     6,    10,     6,
     6,     6,     4,     4,     4,     4,     4,     4,     6,     6,
     6,     4,    10,    10,    22,     8,     4,     4,     8,     4,
     4,     4,     6,     6,     6,     8,     4,     4,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     4,     8,    10,
     3,     4,     4,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     3,     1,     2,     1,     2,     1,     3,     1,
     5,     0,     0
};

static const short yydefact[] = {     0,
    14,     0,     0,     0,     0,     0,     0,    11,    12,     0,
     0,     0,     0,     0,     9,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    88,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    10,    74,    75,    76,     7,     0,     0,     6,
    18,    17,    16,    15,     5,    78,    77,   174,     0,    64,
    65,    66,    68,    70,     0,     0,     0,     0,    25,     8,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   103,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    67,    69,     0,     0,   180,     0,     0,   176,   178,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    63,     0,     0,     0,     0,     0,   182,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    89,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   161,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    43,    81,   180,
     0,    73,     0,   173,   175,   177,     3,     4,     1,     2,
    47,    48,    49,    50,    51,    52,    53,    54,     0,    55,
    56,    57,    58,    59,    60,    61,    62,    71,    72,   171,
     0,     0,     0,    26,    83,    85,   104,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   113,   114,   115,   116,
   117,   118,     0,     0,     0,     0,   122,     0,     0,     0,
     0,     0,   127,   128,   132,     0,   130,   131,   172,   138,
   139,   137,   140,   141,   142,   143,   145,   144,   146,   147,
   148,   149,   153,   150,   151,   152,     0,   158,   162,   154,
   155,   156,   157,    91,    90,    92,    93,    94,     0,    97,
     0,    95,     0,    99,     0,   102,   163,   164,   166,   165,
   167,   168,   169,   170,    87,     0,     0,    79,   179,     0,
     0,    19,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    82,     0,     0,     0,   181,     0,     0,     0,   183,    27,
    84,    86,     0,     0,     0,   108,   107,     0,   110,   111,
   112,   119,   121,   120,     0,   133,   134,   135,     0,     0,
     0,     0,    98,    96,   100,     0,     0,    45,    44,    80,
    35,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   181,     0,     0,     0,    23,
   182,    31,    28,     0,     0,   106,     0,     0,   136,     0,
   126,   129,     0,   159,   101,    46,   181,     0,    20,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    36,     0,    24,   183,    32,    29,   124,     0,   109,   123,
     0,   160,     0,     0,    21,     0,     0,     0,     0,    40,
    37,    33,    30,   105,     0,     0,     0,     0,     0,    41,
    38,    34,     0,     0,     0,    42,     0,     0,     0,     0,
     0,     0,   125,     0,     0,     0
};

static const short yydefgoto[] = {   327,
   100,   101,   477,   562,   478,   550,   102,   238,   444,   515,
   553,   577,   103,   552,   588,   104,   528,   574,   587,   560,
   586,   594,   105,   106,   474,   436,   445,   446,   148,   107,
   206,   207,   208,   209,   108,   353,   514
};

static const short yypact[] = {   720,
-32768,  3493,  3493,  -107,  -106,  3493,   -91,-32768,-32768,   -90,
   -83,   -88,   -87,  3493,-32768,   -64,   -63,   -62,   -61,   -48,
   -47,   -46,   -45,   -44,   -28,   -27,   -26,   -25,   -20,   -19,
    51,    60,    62,    63,    67,    69,    70,    71,    73,    74,
    92,    95,-32768,    96,    97,    98,   100,   105,   124,   125,
   126,   127,   128,   132,   151,   152,   153,   154,   155,   158,
   159,   160,   161,   162,   164,   174,   175,   176,   177,   181,
   182,   203,   204,   205,   206,   207,   210,   211,   213,   214,
   215,   216,   217,  -116,   218,   228,   229,   230,   231,   232,
   233,   245,   -77,    72,-32768,-32768,-32768,  3493,  3493,    -1,
-32768,-32768,-32768,-32768,  3195,-32768,-32768,-32768,   -77,    -7,
    -7,-32768,-32768,    -7,  3493,   270,   197,  3493,-32768,    22,
  3493,  3493,  3493,  3493,  3493,  3493,  3493,  3493,  3493,  3493,
  3493,  3493,  3493,  3493,  3493,  3493,  3493,  3493,  3493,  3493,
  3493,  3493,  3493,  3493,  3493,  3493,  3493,   268,  3493,  3493,
  3493,  3493,  3493,  3493,  3493,  3493,  3493,  3493,  3493,  3493,
  3493,  3493,  3493,  3493,  3493,  3493,  3493,  3493,  3493,  3493,
  3493,  3493,  3493,  3255,  3493,  3493,  3493,  3493,  3493,  3493,
  3493,  3493,  3493,  3493,  3493,  3493,  3493,  3493,-32768,   273,
  3493,  3493,  3493,  3493,  3493,  3493,  3493,  3493,   403,  3493,
-32768,-32768,  3374,  1117,  3222,   269,  3493,-32768,   407,   586,
   586,   586,   586,  3493,  3493,  3493,  3493,  3493,  3493,  3493,
  3493,  3493,  3493,  3493,  3493,  3493,  3493,  3493,  3493,  3493,
-32768,  3493,  3493,  1142,   406,   281,    22,  3493,  1167,  1192,
  1227,  3627,  3654,  3681,  3708,  3735,  3762,  3789,  3816,  3843,
  1252,  1277,  1302,  1327,  1362,  1387,  3870,  3897,  3924,  3951,
  1412,  3978,  4005,  4032,  4059,-32768,  4086,  1437,  1462,  1497,
  4113,  1522,  1547,  1572,  1597,  1632,  1657,  1682,  1707,  1732,
  1767,  1792,  1817,  1842,  1867,  1902,  1927,  1952,  1977,  2002,
  2037,-32768,    49,  2062,  2087,  2112,  2137,  2172,  2197,  2222,
  2247,  2272,  2307,   237,   264,   316,  4140,   275,  2332,  2357,
  2382,  2407,  2442,  2467,  2492,  2517,  3493,    22,-32768,  4167,
   276,-32768,  3493,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  4805,  4805,  4828,  4828,  4828,  4828,  4828,  4828,  4732,   -12,
   -12,   -10,   -10,   -10,   -10,   -10,   -10,    -7,    -7,-32768,
  3493,   278,   280,    22,-32768,-32768,-32768,  3493,  3493,  3493,
  3493,  3493,  3493,  3493,  3493,  3493,-32768,-32768,-32768,-32768,
-32768,-32768,  3493,  3493,  3493,  3493,-32768,  3493,  3493,  3493,
  3493,  3493,-32768,-32768,-32768,   285,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,  3493,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  3493,-32768,
  3493,-32768,  3493,-32768,  3493,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    22,   289,  3493,   415,-32768,  3493,
  4757,   284,   839,   288,   292,   293,  4194,  4221,  4248,  2542,
  2577,  4275,  2602,  2627,  2652,  2677,  2712,  2737,  4302,  2762,
  2787,  2812,  4329,  4356,   425,  4383,  2847,  2872,  2897,  4410,
-32768,  2922,  3493,   295,    85,  3493,  3493,   294,-32768,-32768,
-32768,-32768,  3493,  3493,  3493,-32768,-32768,  3493,-32768,-32768,
-32768,-32768,-32768,-32768,  3493,-32768,-32768,-32768,  3493,  3493,
   300,  3493,-32768,-32768,-32768,  3493,  3493,-32768,    22,-32768,
  4782,   296,   958,   -23,   958,  4437,  4464,  2947,  4491,  4518,
  2982,   377,   298,  1092,  3007,    65,  3493,   299,   958,-32768,
-32768,-32768,-32768,  3493,  3493,-32768,  3493,  3493,-32768,  3493,
-32768,-32768,  3493,-32768,-32768,-32768,   287,   958,-32768,   394,
   958,   304,   401,  3032,  4545,  3057,  3082,  4572,  3117,   303,
-32768,   404,-32768,-32768,-32768,-32768,-32768,  3493,-32768,-32768,
  3493,-32768,   958,   405,-32768,   408,   307,  3142,  4599,-32768,
-32768,-32768,-32768,-32768,  3493,   409,   310,   311,  4626,-32768,
-32768,-32768,  3493,   314,  4653,-32768,  3493,  4680,  3493,  4707,
  3493,  3167,-32768,   450,   451,-32768
};

static const short yypgoto[] = {    27,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    -2,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   246,-32768,-32768,  -177,-32768,   -79,  -109
};


#define	YYLAST		4858


static const short yytable[] = {   110,
   111,   210,   211,   114,   225,   226,   227,   228,   229,   230,
   231,   120,   231,   531,   189,   532,   232,   233,   232,   233,
   190,   232,   233,   112,   113,   321,   604,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,   115,   116,   117,   118,   119,
   232,   233,   407,   199,   214,   215,   216,   217,   218,   219,
   220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
   230,   231,   121,   122,   123,   124,   200,   232,   233,   223,
   224,   225,   226,   227,   228,   229,   230,   231,   125,   126,
   127,   128,   129,   232,   233,   204,   205,   201,   202,   223,
   224,   225,   226,   227,   228,   229,   230,   231,   130,   131,
   132,   133,   234,   232,   233,   237,   134,   135,   239,   240,
   241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
   251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
   261,   262,   263,   264,   265,   439,   267,   268,   269,   270,
   271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
   291,   293,   294,   295,   296,   297,   298,   299,   300,   301,
   302,   303,   304,   305,   306,   307,   408,   136,   309,   310,
   311,   312,   313,   314,   315,   316,   137,   318,   138,   139,
   320,   236,   546,   140,   205,   141,   142,   143,   203,   144,
   145,   331,   332,   333,   334,   335,   336,   337,   338,   339,
   340,   341,   342,   343,   344,   345,   346,   347,   146,   348,
   349,   147,   149,   150,   151,   354,   152,   328,   329,   330,
   419,   153,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
   154,   155,   156,   157,   158,   232,   233,   421,   159,   214,
   215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
   225,   226,   227,   228,   229,   230,   231,   160,   161,   162,
   163,   164,   232,   233,   165,   166,   167,   168,   169,   512,
   170,   223,   224,   225,   226,   227,   228,   229,   230,   231,
   171,   172,   173,   174,   435,   232,   233,   175,   176,   423,
   205,   214,   215,   216,   217,   218,   219,   220,   221,   222,
   223,   224,   225,   226,   227,   228,   229,   230,   231,   177,
   178,   179,   180,   181,   232,   233,   182,   183,   441,   184,
   185,   186,   187,   188,   191,   447,   448,   449,   450,   451,
   452,   453,   454,   455,   192,   193,   194,   195,   196,   197,
   456,   457,   458,   459,   420,   460,   461,   462,   463,   464,
   540,   198,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
   235,   422,   266,   308,   466,   232,   233,   317,   324,   326,
   351,   352,   426,   438,   442,   465,   467,   443,   468,   473,
   469,   -22,   470,   471,   -39,   480,   481,   482,   501,   510,
   523,   513,   563,   529,   472,   542,   548,   475,   565,   566,
   573,   583,   575,   581,   591,   592,   582,   590,   596,   605,
   606,   551,   325,   424,   576,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   479,
   509,     0,     0,   511,   205,     0,     0,     0,     0,     0,
   516,   517,   518,     0,     0,   519,     0,     0,     0,     0,
     0,     0,   520,     0,     0,     0,   521,   522,     0,   524,
     0,     0,     0,   525,   526,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   541,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   547,     0,     0,     0,     0,     0,
     0,   554,   555,     0,   556,   557,     0,   558,     0,   530,
   559,   533,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   549,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   578,     0,     0,   579,     0,
     0,     0,     0,     0,   561,     0,     0,   564,     0,     0,
     0,     0,   589,     0,     0,   -13,     1,     0,     0,     0,
   595,     0,     0,     0,   598,     0,   600,     0,   602,   580,
     2,     3,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     4,     5,     6,     0,     0,     0,     7,     8,     9,
     0,     0,   -13,     0,   -13,     0,     0,     0,     0,    10,
    11,     0,    12,     0,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
    29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
    39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
    49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
    59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,    82,    83,     0,    84,    85,    86,    87,
    88,    89,    90,    91,    92,    93,    94,    95,    96,   -13,
     1,    97,    98,     0,    99,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     2,     3,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     4,     5,     6,     0,     0,
     0,     7,     8,     9,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    10,    11,     0,    12,     0,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
    25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
    35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
    45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
    55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,    82,    83,     1,
    84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
    94,    95,    96,     2,     3,    97,    98,     0,    99,     0,
     0,     0,     0,     0,     4,     5,     6,     0,     0,     0,
     7,     8,     9,     0,     0,   -13,     0,   -13,     0,     0,
     0,     0,    10,    11,     0,    12,     0,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,     1,    84,
    85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
    95,    96,     2,     3,    97,    98,     0,    99,     0,     0,
     0,     0,     0,     4,     5,     6,     0,     0,     0,     7,
     8,     9,     0,     0,     0,     0,   -13,     0,     0,     0,
     0,    10,    11,     0,    12,     0,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,     0,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,     0,     0,    97,    98,   543,    99,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,     0,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,     0,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
   232,   233,     0,     0,     0,     0,     0,     0,     0,   544,
     0,     0,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   322,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   350,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   355,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   356,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,     0,   232,   233,     0,     0,     0,
     0,     0,     0,     0,   357,     0,     0,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   367,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   368,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   369,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   370,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
   232,   233,     0,     0,     0,     0,     0,     0,     0,   371,
     0,     0,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   372,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   377,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   383,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   384,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,     0,   232,   233,     0,     0,     0,
     0,     0,     0,     0,   385,     0,     0,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   387,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   388,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   389,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   390,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
   232,   233,     0,     0,     0,     0,     0,     0,     0,   391,
     0,     0,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   392,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   393,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   394,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   395,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,     0,   232,   233,     0,     0,     0,
     0,     0,     0,     0,   396,     0,     0,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   397,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   398,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   399,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   400,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
   232,   233,     0,     0,     0,     0,     0,     0,     0,   401,
     0,     0,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   402,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   403,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   404,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   405,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,     0,   232,   233,     0,     0,     0,
     0,     0,     0,     0,   406,     0,     0,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   409,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   410,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   411,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   412,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
   232,   233,     0,     0,     0,     0,     0,     0,     0,   413,
     0,     0,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   414,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   415,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   416,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   417,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,     0,   232,   233,     0,     0,     0,
     0,     0,     0,     0,   418,     0,     0,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   427,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   428,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   429,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   430,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
   232,   233,     0,     0,     0,     0,     0,     0,     0,   431,
     0,     0,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   432,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   433,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   434,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   486,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,     0,   232,   233,     0,     0,     0,
     0,     0,     0,     0,   487,     0,     0,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   489,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   490,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   491,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   492,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
   232,   233,     0,     0,     0,     0,     0,     0,     0,   493,
     0,     0,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   494,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   496,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   497,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   507,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   498,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,     0,   232,   233,     0,     0,     0,
     0,     0,     0,     0,   503,     0,     0,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   504,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   505,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   508,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   536,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
   232,   233,     0,     0,     0,     0,     0,     0,     0,   539,
     0,     0,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   545,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,   567,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,   569,   232,   233,   212,   213,     0,
   214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
   224,   225,   226,   227,   228,   229,   230,   231,     0,   570,
     0,     0,     0,   232,   233,   323,     0,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
   232,   233,     0,     0,   572,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     2,
     3,     0,     0,     0,     0,     0,     0,     0,     0,   584,
     4,     5,     6,     0,     0,     0,     7,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   603,     0,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
    40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
    50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
    60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,    82,    83,     0,    84,    85,    86,    87,    88,
    89,    90,    91,    92,   109,    94,    95,    96,     2,     3,
     0,    98,   292,    99,     0,     0,     0,     0,     0,     4,
     5,     6,     0,     0,     0,     7,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    16,    17,    18,    19,    20,
    21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
    51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
    61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    81,    82,    83,     0,    84,    85,    86,    87,    88,    89,
    90,    91,    92,   109,    94,    95,    96,     2,     3,     0,
    98,   319,    99,     0,     0,     0,     0,     0,     4,     5,
     6,     0,     0,     0,     7,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    16,    17,    18,    19,    20,    21,
    22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
    42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
    82,    83,     0,    84,    85,    86,    87,    88,    89,    90,
    91,    92,   109,    94,    95,    96,     0,     0,     0,    98,
   358,    99,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,     0,   232,   233,   359,     0,   214,
   215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
   225,   226,   227,   228,   229,   230,   231,     0,     0,     0,
     0,     0,   232,   233,   360,     0,   214,   215,   216,   217,
   218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
   228,   229,   230,   231,     0,     0,     0,     0,     0,   232,
   233,   361,     0,   214,   215,   216,   217,   218,   219,   220,
   221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
   231,     0,     0,     0,     0,     0,   232,   233,   362,     0,
   214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
   224,   225,   226,   227,   228,   229,   230,   231,     0,     0,
     0,     0,     0,   232,   233,   363,     0,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
   232,   233,   364,     0,   214,   215,   216,   217,   218,   219,
   220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
   230,   231,     0,     0,     0,     0,     0,   232,   233,   365,
     0,   214,   215,   216,   217,   218,   219,   220,   221,   222,
   223,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     0,     0,     0,     0,   232,   233,   366,     0,   214,   215,
   216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
   226,   227,   228,   229,   230,   231,     0,     0,     0,     0,
     0,   232,   233,   373,     0,   214,   215,   216,   217,   218,
   219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
   229,   230,   231,     0,     0,     0,     0,     0,   232,   233,
   374,     0,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,     0,   232,   233,   375,     0,   214,
   215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
   225,   226,   227,   228,   229,   230,   231,     0,     0,     0,
     0,     0,   232,   233,   376,     0,   214,   215,   216,   217,
   218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
   228,   229,   230,   231,     0,     0,     0,     0,     0,   232,
   233,   378,     0,   214,   215,   216,   217,   218,   219,   220,
   221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
   231,     0,     0,     0,     0,     0,   232,   233,   379,     0,
   214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
   224,   225,   226,   227,   228,   229,   230,   231,     0,     0,
     0,     0,     0,   232,   233,   380,     0,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
   232,   233,   381,     0,   214,   215,   216,   217,   218,   219,
   220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
   230,   231,     0,     0,     0,     0,     0,   232,   233,   382,
     0,   214,   215,   216,   217,   218,   219,   220,   221,   222,
   223,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     0,     0,     0,     0,   232,   233,   386,     0,   214,   215,
   216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
   226,   227,   228,   229,   230,   231,     0,     0,     0,     0,
     0,   232,   233,   425,     0,   214,   215,   216,   217,   218,
   219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
   229,   230,   231,     0,     0,     0,     0,     0,   232,   233,
   323,     0,   214,   215,   216,   217,   218,   219,   220,   221,
   437,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,     0,   232,   233,   483,     0,   214,
   215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
   225,   226,   227,   228,   229,   230,   231,     0,     0,     0,
     0,     0,   232,   233,   484,     0,   214,   215,   216,   217,
   218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
   228,   229,   230,   231,     0,     0,     0,     0,     0,   232,
   233,   485,     0,   214,   215,   216,   217,   218,   219,   220,
   221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
   231,     0,     0,     0,     0,     0,   232,   233,   488,     0,
   214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
   224,   225,   226,   227,   228,   229,   230,   231,     0,     0,
     0,     0,     0,   232,   233,   495,     0,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
   232,   233,   499,     0,   214,   215,   216,   217,   218,   219,
   220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
   230,   231,     0,     0,     0,     0,     0,   232,   233,   500,
     0,   214,   215,   216,   217,   218,   219,   220,   221,   222,
   223,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     0,     0,     0,     0,   232,   233,   502,     0,   214,   215,
   216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
   226,   227,   228,   229,   230,   231,     0,     0,     0,     0,
     0,   232,   233,   506,     0,   214,   215,   216,   217,   218,
   219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
   229,   230,   231,     0,     0,     0,     0,     0,   232,   233,
   534,     0,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,     0,   232,   233,   535,     0,   214,
   215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
   225,   226,   227,   228,   229,   230,   231,     0,     0,     0,
     0,     0,   232,   233,   537,     0,   214,   215,   216,   217,
   218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
   228,   229,   230,   231,     0,     0,     0,     0,     0,   232,
   233,   538,     0,   214,   215,   216,   217,   218,   219,   220,
   221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
   231,     0,     0,     0,     0,     0,   232,   233,   568,     0,
   214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
   224,   225,   226,   227,   228,   229,   230,   231,     0,     0,
     0,     0,     0,   232,   233,   571,     0,   214,   215,   216,
   217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
   232,   233,   585,     0,   214,   215,   216,   217,   218,   219,
   220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
   230,   231,     0,     0,     0,     0,     0,   232,   233,   593,
     0,   214,   215,   216,   217,   218,   219,   220,   221,   222,
   223,   224,   225,   226,   227,   228,   229,   230,   231,     0,
     0,     0,     0,     0,   232,   233,   597,     0,   214,   215,
   216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
   226,   227,   228,   229,   230,   231,     0,     0,     0,     0,
     0,   232,   233,   599,     0,   214,   215,   216,   217,   218,
   219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
   229,   230,   231,     0,     0,     0,     0,     0,   232,   233,
   601,     0,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,     0,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   440,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
   232,   233,   214,   215,   216,   217,   218,   219,   220,   221,
   476,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     0,     0,     0,     0,     0,   232,   233,   214,   215,   216,
   217,   218,   219,   220,   221,   527,   223,   224,   225,   226,
   227,   228,   229,   230,   231,     0,     0,     0,     0,     0,
   232,   233,   216,   217,   218,   219,   220,   221,   222,   223,
   224,   225,   226,   227,   228,   229,   230,   231,     0,     0,
     0,     0,     0,   232,   233,-32768,-32768,-32768,-32768,-32768,
-32768,   222,   223,   224,   225,   226,   227,   228,   229,   230,
   231,     0,     0,     0,     0,     0,   232,   233
};

static const short yycheck[] = {     2,
     3,     3,     4,     6,    17,    18,    19,    20,    21,    22,
    23,    14,    23,    37,   131,    39,    29,    30,    29,    30,
   137,    29,    30,   131,   131,   203,     0,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,   137,   137,   131,   137,   137,
    29,    30,     4,   131,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    23,   137,   137,   137,   137,     5,    29,    30,    15,
    16,    17,    18,    19,    20,    21,    22,    23,   137,   137,
   137,   137,   137,    29,    30,    98,    99,    26,    27,    15,
    16,    17,    18,    19,    20,    21,    22,    23,   137,   137,
   137,   137,   115,    29,    30,   118,   137,   137,   121,   122,
   123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
   133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
   143,   144,   145,   146,   147,   323,   149,   150,   151,   152,
   153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
   163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
   173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
   183,   184,   185,   186,   187,   188,   138,   137,   191,   192,
   193,   194,   195,   196,   197,   198,   137,   200,   137,   137,
   203,     5,   138,   137,   207,   137,   137,   137,   137,   137,
   137,   214,   215,   216,   217,   218,   219,   220,   221,   222,
   223,   224,   225,   226,   227,   228,   229,   230,   137,   232,
   233,   137,   137,   137,   137,   238,   137,   211,   212,   213,
     4,   137,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
   137,   137,   137,   137,   137,    29,    30,     4,   137,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,   137,   137,   137,
   137,   137,    29,    30,   137,   137,   137,   137,   137,   477,
   137,    15,    16,    17,    18,    19,    20,    21,    22,    23,
   137,   137,   137,   137,   317,    29,    30,   137,   137,     4,
   323,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,   137,
   137,   137,   137,   137,    29,    30,   137,   137,   351,   137,
   137,   137,   137,   137,   137,   358,   359,   360,   361,   362,
   363,   364,   365,   366,   137,   137,   137,   137,   137,   137,
   373,   374,   375,   376,   138,   378,   379,   380,   381,   382,
     4,   137,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
   131,   138,   135,   131,   407,    29,    30,     5,   140,     3,
     5,   131,   138,   138,   137,   131,   419,   138,   421,     5,
   423,   138,   425,   135,   138,   138,   135,   135,     4,   135,
   131,   138,    39,   138,   437,   138,   138,   440,   135,    39,
   138,   135,    39,    39,   135,   135,    39,    39,   135,     0,
     0,   531,   207,   138,   564,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   443,
   473,    -1,    -1,   476,   477,    -1,    -1,    -1,    -1,    -1,
   483,   484,   485,    -1,    -1,   488,    -1,    -1,    -1,    -1,
    -1,    -1,   495,    -1,    -1,    -1,   499,   500,    -1,   502,
    -1,    -1,    -1,   506,   507,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   138,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   527,    -1,    -1,    -1,    -1,    -1,
    -1,   534,   535,    -1,   537,   538,    -1,   540,    -1,   513,
   543,   515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   529,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   568,    -1,    -1,   571,    -1,
    -1,    -1,    -1,    -1,   548,    -1,    -1,   551,    -1,    -1,
    -1,    -1,   585,    -1,    -1,     0,     1,    -1,    -1,    -1,
   593,    -1,    -1,    -1,   597,    -1,   599,    -1,   601,   573,
    15,    16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    26,    27,    28,    -1,    -1,    -1,    32,    33,    34,
    -1,    -1,    37,    -1,    39,    -1,    -1,    -1,    -1,    44,
    45,    -1,    47,    -1,    49,    50,    51,    52,    53,    54,
    55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
    85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
    95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
   105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
   115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,   133,     0,
     1,   136,   137,    -1,   139,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    15,    16,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    26,    27,    28,    -1,    -1,
    -1,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    44,    45,    -1,    47,    -1,    49,    50,
    51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
    61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
    91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
   101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
   111,   112,   113,   114,   115,   116,   117,   118,   119,     1,
   121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
   131,   132,   133,    15,    16,   136,   137,    -1,   139,    -1,
    -1,    -1,    -1,    -1,    26,    27,    28,    -1,    -1,    -1,
    32,    33,    34,    -1,    -1,    37,    -1,    39,    -1,    -1,
    -1,    -1,    44,    45,    -1,    47,    -1,    49,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
    82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
    92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
   102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
   112,   113,   114,   115,   116,   117,   118,   119,     1,   121,
   122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
   132,   133,    15,    16,   136,   137,    -1,   139,    -1,    -1,
    -1,    -1,    -1,    26,    27,    28,    -1,    -1,    -1,    32,
    33,    34,    -1,    -1,    -1,    -1,    39,    -1,    -1,    -1,
    -1,    44,    45,    -1,    47,    -1,    49,    50,    51,    52,
    53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
    83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
    93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
   103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
   113,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
   123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
   133,    -1,    -1,   136,   137,     4,   139,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,    -1,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,    -1,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,
    -1,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,    -1,    29,    30,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   138,    -1,    -1,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,
    -1,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,    -1,    29,    30,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   138,    -1,    -1,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,
    -1,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,    -1,    29,    30,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   138,    -1,    -1,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,
    -1,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,    -1,    29,    30,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   138,    -1,    -1,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,
    -1,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,    -1,    29,    30,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   138,    -1,    -1,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,
    -1,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,    -1,    29,    30,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   138,    -1,    -1,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,
    -1,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,    -1,    29,    30,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   138,    -1,    -1,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,
    -1,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,   138,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,   138,    29,    30,     3,     4,    -1,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    -1,   138,
    -1,    -1,    -1,    29,    30,     4,    -1,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
    29,    30,    -1,    -1,   138,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    15,
    16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,
    26,    27,    28,    -1,    -1,    -1,    32,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   138,    -1,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
   106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
   116,   117,   118,   119,    -1,   121,   122,   123,   124,   125,
   126,   127,   128,   129,   130,   131,   132,   133,    15,    16,
    -1,   137,   138,   139,    -1,    -1,    -1,    -1,    -1,    26,
    27,    28,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
   107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
   117,   118,   119,    -1,   121,   122,   123,   124,   125,   126,
   127,   128,   129,   130,   131,   132,   133,    15,    16,    -1,
   137,   138,   139,    -1,    -1,    -1,    -1,    -1,    26,    27,
    28,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,    57,
    58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
    68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
    78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
    88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
    98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
   108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
   118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
   128,   129,   130,   131,   132,   133,    -1,    -1,    -1,   137,
     4,   139,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,    -1,    29,    30,     4,    -1,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    -1,    -1,    -1,
    -1,    -1,    29,    30,     4,    -1,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,    29,
    30,     4,    -1,     6,     7,     8,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    -1,    -1,    -1,    -1,    -1,    29,    30,     4,    -1,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    -1,    -1,
    -1,    -1,    -1,    29,    30,     4,    -1,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
    29,    30,     4,    -1,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    23,    -1,    -1,    -1,    -1,    -1,    29,    30,     4,
    -1,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    -1,
    -1,    -1,    -1,    -1,    29,    30,     4,    -1,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,
    -1,    29,    30,     4,    -1,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    -1,    -1,    -1,    -1,    -1,    29,    30,
     4,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,    -1,    29,    30,     4,    -1,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    -1,    -1,    -1,
    -1,    -1,    29,    30,     4,    -1,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,    29,
    30,     4,    -1,     6,     7,     8,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    -1,    -1,    -1,    -1,    -1,    29,    30,     4,    -1,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    -1,    -1,
    -1,    -1,    -1,    29,    30,     4,    -1,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
    29,    30,     4,    -1,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    23,    -1,    -1,    -1,    -1,    -1,    29,    30,     4,
    -1,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    -1,
    -1,    -1,    -1,    -1,    29,    30,     4,    -1,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,
    -1,    29,    30,     4,    -1,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    -1,    -1,    -1,    -1,    -1,    29,    30,
     4,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,    -1,    29,    30,     4,    -1,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    -1,    -1,    -1,
    -1,    -1,    29,    30,     4,    -1,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,    29,
    30,     4,    -1,     6,     7,     8,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    -1,    -1,    -1,    -1,    -1,    29,    30,     4,    -1,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    -1,    -1,
    -1,    -1,    -1,    29,    30,     4,    -1,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
    29,    30,     4,    -1,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    23,    -1,    -1,    -1,    -1,    -1,    29,    30,     4,
    -1,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    -1,
    -1,    -1,    -1,    -1,    29,    30,     4,    -1,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,
    -1,    29,    30,     4,    -1,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    -1,    -1,    -1,    -1,    -1,    29,    30,
     4,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,    -1,    29,    30,     4,    -1,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    -1,    -1,    -1,
    -1,    -1,    29,    30,     4,    -1,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,    29,
    30,     4,    -1,     6,     7,     8,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    -1,    -1,    -1,    -1,    -1,    29,    30,     4,    -1,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    -1,    -1,
    -1,    -1,    -1,    29,    30,     4,    -1,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
    29,    30,     4,    -1,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    23,    -1,    -1,    -1,    -1,    -1,    29,    30,     4,
    -1,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    -1,
    -1,    -1,    -1,    -1,    29,    30,     4,    -1,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,
    -1,    29,    30,     4,    -1,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    -1,    -1,    -1,    -1,    -1,    29,    30,
     4,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,    -1,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
    29,    30,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    -1,    -1,    -1,    -1,    -1,    29,    30,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
    29,    30,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    -1,    -1,
    -1,    -1,    -1,    29,    30,     8,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    -1,    -1,    -1,    -1,    -1,    29,    30
};
#define YYPURE 1

/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 327 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 1 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, ";");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
  }				// end else
;
    break;}
case 2:
#line 345 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 1 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    output (yyvsp[-2].val);
    sp_out("\n");
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
  }				// end else
;
    break;}
case 3:
#line 365 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 1 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, ";");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
  }				// end else
;
    break;}
case 4:
#line 383 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 1 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, ";");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    output (yyvsp[-2].val);
    sp_out("\n");
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
  }				// end else
;
    break;}
case 5:
#line 403 "spmath.y"
{
  if (text_flag)
    yyval.val = yyvsp[0].val;
  else {
    output (yyvsp[0].val);
    sp_out("\n");
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }
;
    break;}
case 6:
#line 414 "spmath.y"
{
  if (text_flag)
    yyval.val = yyvsp[0].val;
  else {
    output (yyvsp[0].val);
    sp_out("\n");
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end else
;
    break;}
case 7:
#line 427 "spmath.y"
{
  if (text_flag)
    yyval.val = new value (yyvsp[0].name);
  else
    system (yyvsp[0].name + 1);
;
    break;}
case 8:
#line 436 "spmath.y"
{
  if (text_flag) {
    sp_error("Error, can't reference history list inside an expression.\n");
    YYERROR;
  }				// end if
  if (yyvsp[0].val->type != NUM) {
    sp_error("Error, reference to history list must be a number.\n");
    YYERROR;
  }				// end if
  str_flag = 1;
  str =
    new char[strlen (hist_list.get_item (int (yyvsp[0].val->num)).get_pointer ()) + 1];
  strcpy (str, hist_list.get_item (int (yyvsp[0].val->num)).get_pointer ());
  strcat (str, "$");
  yyrestart (yyin);
  yyparse ();
;
    break;}
case 9:
#line 456 "spmath.y"
{
  if (text_flag) {
    yyval.val = new value (strdup ("history"));
  }
  else {
    output (hist_list);
    yyval.val = new value ();
  }
;
    break;}
case 10:
#line 468 "spmath.y"
{
  if (text_flag) {
    yyval.val = new value (strdup ("alias"));
  }
  else {
    ali->out_alias ();
    yyval.val = new value ();
  }
;
    break;}
case 11:
#line 480 "spmath.y"
{
  if (text_flag) {
    yyval.val = new value(strdup ("who"));
  }
  else {
    syms->out();
    yyval.val = new value();
  }
;
    break;}
case 12:
#line 492 "spmath.y"
{
  if (text_flag) {
    yyval.val = new value(strdup ("whos"));
  }
  else {
    syms->out_fancy();
    yyval.val = new value();
  }
;
    break;}
case 13:
#line 502 "spmath.y"
{
  if (text_flag)
    yyval.val = new value (strdup (""));
;
    break;}
case 14:
#line 507 "spmath.y"
{
  yyrestart (yyin);
  text_flag = 0;
  str_flag = 0;
  return 0;
;
    break;}
case 15:
#line 517 "spmath.y"
{
  if (text_flag)
    yyval.val = yyvsp[0].val;
  else
    yyval.val = yyvsp[0].val;
;
    break;}
case 16:
#line 524 "spmath.y"
{
  if (text_flag)
    yyval.val = yyvsp[0].val;
  else
    yyval.val = yyvsp[0].val;
;
    break;}
case 17:
#line 531 "spmath.y"
{
  if (text_flag)
    yyval.val = yyvsp[0].val;
  else
    yyval.val = yyvsp[0].val;
;
    break;}
case 18:
#line 538 "spmath.y"
{
  if (text_flag)
    yyval.val = yyvsp[0].val;
  else
    yyval.val = yyvsp[0].val;
;
    break;}
case 19:
#line 549 "spmath.y"
{ 
  text_flag += 1;
;
    break;}
case 20:
#line 551 "spmath.y"
{ 
  text_flag -= 1; 
;
    break;}
case 21:
#line 553 "spmath.y"
{
  if (text_flag) {
    yyvsp[-4].set->init_curr_prev ();
    int len = strlen (yyvsp[-4].set->get_current ().get_value ().str) + 1;
    while (!yyvsp[-4].set->end ()) {
      yyvsp[-4].set->get_next ();
      len += strlen (yyvsp[-4].set->get_current ().get_value ().str) + 1;
    }				// end while
    char *temp =
      new char[8 + strlen (yyvsp[-9].name) + 1 + strlen (yyvsp[-7].name) + 1 + len + 1 +
	       strlen (yyvsp[-2].val->str) + 3];
    yyvsp[-4].set->init_curr_prev ();
    strcpy (temp, "function");
    strcat (temp, yyvsp[-9].name);
    strcpy (temp, "=");
    strcat (temp, yyvsp[-7].name);
    strcpy (temp, "(");
    strcat (temp, yyvsp[-4].set->get_current ().get_value ().str);
    while (!yyvsp[-4].set->end ()) {
      yyvsp[-4].set->get_next ();
      strcat (temp, ",");
      strcat (temp, yyvsp[-4].set->get_current ().get_value ().str);
    }				// end while
    strcpy (temp, ")");
    strcat (temp, yyvsp[-2].val->str);
    strcpy (temp, "end");
    yyval.val = new value (temp);
    yyvsp[-4].set->remove_all ();
    delete yyvsp[-4].set;
    delete[] yyvsp[-9].name;
    delete[] yyvsp[-7].name;
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
  }				// end if
  else {
    yyvsp[-4].set->init_curr_prev ();
    int len = strlen (yyvsp[-4].set->get_current ().get_value ().str) + 1;
    while (!yyvsp[-4].set->end ()) {
      yyvsp[-4].set->get_next ();
      len += strlen (yyvsp[-4].set->get_current ().get_value ().str) + 1;
    }				// end while
    char *temp = new char[1 + len + 1];
    yyvsp[-4].set->init_curr_prev ();
    strcpy (temp, "(");
    strcat (temp, yyvsp[-4].set->get_current ().get_value ().str);
    while (!yyvsp[-4].set->end ()) {
      yyvsp[-4].set->get_next ();
      strcat (temp, ",");
      strcat (temp, yyvsp[-4].set->get_current ().get_value ().str);
    }				// end while
    strcat (temp, ")");
    root.insert (entry (yyvsp[-7].name, value (new funct_def (yyvsp[-9].name, temp, yyvsp[-2].val->str))));
    yyval.val = new value ();
    yyvsp[-4].set->remove_all ();
    delete yyvsp[-4].set;
    delete yyvsp[-2].val;
  }				// end else
;
    break;}
case 22:
#line 612 "spmath.y"
{ 
  text_flag += 1; 
;
    break;}
case 23:
#line 614 "spmath.y"
{ 
  text_flag -= 1; 
;
    break;}
case 24:
#line 616 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[8 + strlen (yyvsp[-8].name) + 1 + strlen (yyvsp[-6].name) + 1 + 1 + strlen (yyvsp[-2].val->str) +
	       3];
    strcpy (temp, "function");
    strcat (temp, yyvsp[-8].name);
    strcpy (temp, "=");
    strcat (temp, yyvsp[-6].name);
    strcpy (temp, "()");
    strcat (temp, yyvsp[-2].val->str);
    strcpy (temp, "end");
    yyval.val = new value (temp);
    delete[] yyvsp[-8].name;
    delete[] yyvsp[-6].name;
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
  }				// end if
  else {
    char *temp = new char[1 + 1];
    strcpy (temp, "()");
    root.insert (entry (yyvsp[-6].name, value (new funct_def (yyvsp[-8].name, temp, yyvsp[-2].val->str))));
    yyval.val = new value ();
    delete yyvsp[-2].val;
  }				// end else
;
    break;}
case 25:
#line 646 "spmath.y"
{ 
  text_flag += 1; 
;
    break;}
case 26:
#line 648 "spmath.y"
{ 
  text_flag -= 1; 
;
    break;}
case 27:
#line 650 "spmath.y"
{ 
  text_flag += 1; 
;
    break;}
case 28:
#line 652 "spmath.y"
{ 
  text_flag -= 1; 
;
    break;}
case 29:
#line 654 "spmath.y"
{ 
  // Send lex into "catch-all" mode where it reads everything
  // up the next dollar sign and then returns it as a string
  // (without tokenizing it).
  my_yybegin(CATCH_MODE);   
;
    break;}
case 30:
#line 659 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[5 + 1 + strlen (yyvsp[-8].val->str) + 1 +
			  strlen (yyvsp[-4].val->str) + 3 + strlen (yyvsp[0].name)];
    strcpy (temp, "while(");
    strcat (temp, yyvsp[-8].val->str);
    strcat (temp, ")");
    strcat (temp, yyvsp[-4].val->str);
    strcat (temp, "end");
    strcat (temp, yyvsp[0].name);
    yyval.val = new value (temp);
    yyvsp[-8].val->free ();
    delete yyvsp[-8].val;
    yyvsp[-4].val->free ();
    delete yyvsp[-4].val;
    delete[] yyvsp[0].name;
  }				// end if
  else {
    str_flag = 1;
    str = new char[strlen (yyvsp[-8].val->str) + 8 + 3];
    strcpy (str, "_bo_ol_=");
    strcat (str, yyvsp[-8].val->str);
    strcat (str, "; $");
    yyrestart (yyin);
    yyparse ();
    value temp (syms->lookup ("_bo_ol_").get_value ());
    value one (1);
    while (_and (&temp, &one, err)->num) {
      str_flag = 1;
      str = new char[strlen (yyvsp[-4].val->str) + 2];
      strcpy (str, yyvsp[-4].val->str);
      strcat (str, " $");
      yyrestart (yyin);
      yyparse ();
      str_flag = 1;
      str = new char[strlen (yyvsp[-8].val->str) + 8 + 3];
      strcpy (str, "_bo_ol_=");
      strcat (str, yyvsp[-8].val->str);
      strcat (str, "; $");
      yyrestart (yyin);
      yyparse ();
      temp = (syms->lookup ("_bo_ol_").get_value ());
    }				// end while
    str_flag = 1;
    str = new char[strlen (yyvsp[0].name)];
    strcpy (str, yyvsp[0].name);
    yyrestart (yyin);
    yyval.val = new value ();
    yyvsp[-8].val->free ();
    delete yyvsp[-8].val;
    yyvsp[-4].val->free ();
    delete yyvsp[-4].val;
    delete[] yyvsp[0].name;
  }				// end else
;
    break;}
case 31:
#line 717 "spmath.y"
{
  // Begin catching if statement body
  my_yybegin(CATCH_MODE) ;   
;
    break;}
case 32:
#line 720 "spmath.y"
{

  if (text_flag) {
    char *temp = new char[2 + 1 + strlen (yyvsp[-7].val->str) + 1 +
			  strlen (yyvsp[-4].val->str) + 3 + strlen (yyvsp[0].name)];
    strcpy (temp, "if(");
    strcat (temp, yyvsp[-7].val->str);
    strcat (temp, ")");
    strcat (temp, yyvsp[-4].val->str);
    strcat (temp, "end");
    strcat (temp, yyvsp[0].name);
    yyval.val = new value (temp);
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-4].val->free ();
    delete yyvsp[-4].val;
    delete[] yyvsp[0].name;
  }				// end if
  else {
    value one (1);
    if (_and (yyvsp[-7].val, &one, err)->num) {
      str_flag = 1;
      str = new char[strlen (yyvsp[-4].val->str) + 2];
      strcpy (str, yyvsp[-4].val->str);
      strcat (str, " $");
      yyrestart (yyin);
      yyparse ();
    }				// end if
    str_flag = 1;
    str = new char[strlen (yyvsp[0].name)];
    strcpy (str, yyvsp[0].name);
    yyrestart (yyin);
    yyval.val = new value ();
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-4].val->free ();
    delete yyvsp[-4].val;
    delete[] yyvsp[0].name;
  }				// end else
;
    break;}
case 33:
#line 761 "spmath.y"
{
  // Begin catching if statement body
  my_yybegin(CATCH_MODE);   
;
    break;}
case 34:
#line 764 "spmath.y"
{

  if (text_flag) {
    char *temp = new char[2 + 1 + strlen (yyvsp[-11].val->str) + 1 +
			  strlen (yyvsp[-8].val->str) + 4 + strlen (yyvsp[-4].val->str) + 3 +
			  strlen (yyvsp[0].name)];
    strcpy (temp, "if(");
    strcat (temp, yyvsp[-11].val->str);
    strcat (temp, ")");
    strcat (temp, yyvsp[-8].val->str);
    strcat (temp, "else");
    strcat (temp, yyvsp[-4].val->str);
    strcat (temp, "end");
    strcat (temp, yyvsp[0].name);
    yyval.val = new value (temp);
    yyvsp[-11].val->free ();
    delete yyvsp[-11].val;
    yyvsp[-8].val->free ();
    delete yyvsp[-8].val;
    yyvsp[-4].val->free ();
    delete yyvsp[-4].val;
    delete[] yyvsp[0].name;
  }				// end if
  else {
    value one (1);
    if (_and (yyvsp[-11].val, &one, err)->num) {
      str_flag = 1;
      str = new char[strlen (yyvsp[-8].val->str) + 2];
      strcpy (str, yyvsp[-8].val->str);
      strcat (str, " $");
      yyrestart (yyin);
      yyparse ();
    }				// end if
    else {
      str_flag = 1;
      str = new char[strlen (yyvsp[-4].val->str) + 2];
      strcpy (str, yyvsp[-4].val->str);
      strcat (str, " $");
      yyrestart (yyin);
      yyparse ();
    }
    str_flag = 1;
    str = new char[strlen (yyvsp[0].name)];
    strcpy (str, yyvsp[0].name);
    yyrestart (yyin);
    yyval.val = new value ();
    yyvsp[-11].val->free ();
    delete yyvsp[-11].val;
    yyvsp[-8].val->free ();
    delete yyvsp[-8].val;
    yyvsp[-4].val->free ();
    delete yyvsp[-4].val;
    delete[] yyvsp[0].name;
  }				// end else
;
    break;}
case 35:
#line 823 "spmath.y"
{ 
  text_flag += 1; 
;
    break;}
case 36:
#line 825 "spmath.y"
{ 
  text_flag -= 1; 
;
    break;}
case 37:
#line 827 "spmath.y"
{   
  // Start catching for statement body
  my_yybegin(CATCH_MODE);   
;
    break;}
case 38:
#line 830 "spmath.y"
{

  if (text_flag) {
    char *temp = new char[3 + 1 + strlen (yyvsp[-11].name) + 1 +
			  strlen (yyvsp[-9].val->str) + 1 +
			  strlen (yyvsp[-7].val->str) + 1 +
			  strlen (yyvsp[-4].val->str) + 3 + strlen (yyvsp[0].name)];
    strcpy (temp, "for(");
    strcat (temp, yyvsp[-11].name);
    strcat (temp, "=");
    strcat (temp, yyvsp[-9].val->str);
    strcat (temp, ":");
    strcat (temp, yyvsp[-7].val->str);
    strcat (temp, ")");
    strcat (temp, yyvsp[-4].val->str);
    strcat (temp, "end");
    strcat (temp, yyvsp[0].name);
    yyval.val = new value (temp);
    delete[] yyvsp[-11].name;
    yyvsp[-9].val->free ();
    delete yyvsp[-9].val;
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-4].val->free ();
    delete yyvsp[-4].val;
    delete[] yyvsp[0].name;
  }				// end if
  else {
    syms->insert (entry (strdup (yyvsp[-11].name), *yyvsp[-9].val));
    value temp (syms->lookup (yyvsp[-11].name).get_value ());
    while (le (&temp, yyvsp[-7].val, err)->num != (0)) {
      str_flag = 1;
      str = new char[strlen (yyvsp[-4].val->str) + 2];
      strcpy (str, yyvsp[-4].val->str);
      strcat (str, " $");
      yyrestart (yyin);
      yyparse ();
      value vone (1);
      temp = (syms->lookup (yyvsp[-11].name).get_value ());
      temp = *plus (&temp, &vone, err);
      syms->insert (entry (strdup (yyvsp[-11].name), temp));
    }				// end while
    str_flag = 1;
    str = new char[strlen (yyvsp[0].name)];
    strcpy (str, yyvsp[0].name);
    yyrestart (yyin);
    yyval.val = new value ();
    delete[] yyvsp[-11].name;
    delete yyvsp[-9].val;
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-4].val->free ();
    delete yyvsp[-4].val;
    delete[] yyvsp[0].name;
  }				// end else
;
    break;}
case 39:
#line 887 "spmath.y"
{
  text_flag += 1;
;
    break;}
case 40:
#line 889 "spmath.y"
{
  text_flag -= 1;
;
    break;}
case 41:
#line 891 "spmath.y"
{
  // Start catching for statement body
  my_yybegin(CATCH_MODE);
;
    break;}
case 42:
#line 894 "spmath.y"
{

  if (text_flag) {
    char *temp = new char[3 + 1 + strlen (yyvsp[-13].name) + 1 +
			  strlen (yyvsp[-11].val->str) + 1 +
			  strlen (yyvsp[-9].val->str) + 1 +
			  strlen (yyvsp[-7].val->str) + 1 +
			  strlen (yyvsp[-4].val->str) + 3 + strlen (yyvsp[0].name)];
    strcpy (temp, "for(");
    strcat (temp, yyvsp[-13].name);
    strcat (temp, "=");
    strcat (temp, yyvsp[-11].val->str);
    strcat (temp, ":");
    strcat (temp, yyvsp[-9].val->str);
    strcat (temp, ":");
    strcat (temp, yyvsp[-7].val->str);
    strcat (temp, ")");
    strcat (temp, yyvsp[-4].val->str);
    strcat (temp, "end");
    strcat (temp, yyvsp[0].name);
    yyval.val = new value (temp);
    delete[] yyvsp[-13].name;
    yyvsp[-11].val->free ();
    delete yyvsp[-11].val;
    yyvsp[-9].val->free ();
    delete yyvsp[-9].val;
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-4].val->free ();
    delete yyvsp[-4].val;
    delete[] yyvsp[0].name;
  }				// end if
  else {
    syms->insert (entry (strdup (yyvsp[-13].name), *yyvsp[-11].val));
    value temp (syms->lookup (yyvsp[-13].name).get_value ());
    while (le (&temp, yyvsp[-7].val, err)->num != (0)) {
      str_flag = 1;
      str = new char[strlen (yyvsp[-4].val->str) + 2];
      strcpy (str, yyvsp[-4].val->str);
      strcat (str, " $");
      yyrestart (yyin);
      yyparse ();
      temp = (syms->lookup (yyvsp[-13].name).get_value ());
      temp = *plus (&temp, yyvsp[-9].val, err);
      syms->insert (entry (strdup (yyvsp[-13].name), temp));
    }				// end while
    str_flag = 1;
    str = new char[strlen (yyvsp[0].name)];
    strcpy (str, yyvsp[0].name);
    yyrestart (yyin);
    yyval.val = new value ();
    delete[] yyvsp[-13].name;
    delete yyvsp[-11].val;
    yyvsp[-9].val->free ();
    delete yyvsp[-9].val;
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-4].val->free ();
    delete yyvsp[-4].val;
    delete[] yyvsp[0].name;
  }				// end else
;
    break;}
case 43:
#line 961 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].name) + 1 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].name);
    strcat (temp, "=");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    delete[] yyvsp[-2].name;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    if (yyvsp[0].val->type != FUNCT)
      syms->insert (entry (yyvsp[-2].name, *yyvsp[0].val));
    if (yyvsp[0].val->type == NUM)
      yyvsp[0].val->num = (yyvsp[0].val->num);
    else if (yyvsp[0].val->type == DENSE)
      yyvsp[0].val->dmat = new dense (*yyvsp[0].val->dmat);
    else if (yyvsp[0].val->type == SPARSE)
      yyvsp[0].val->smat = new sparse (*yyvsp[0].val->smat);
    else if (yyvsp[0].val->type == STRING)
      yyvsp[0].val->str = strdup (yyvsp[0].val->str);
    else {
      sp_error ("Error, invalid type for operator assign.\n");
      YYERROR;
    }				// end else
    yyval.val = yyvsp[0].val;
  }				// end else
;
    break;}
case 44:
#line 994 "spmath.y"
{
  if (text_flag) {
    yyvsp[-3].set->init_curr_prev ();
    int len = strlen (yyvsp[-3].set->get_current ().get_value ().str) + 1;
    while (!yyvsp[-3].set->end ()) {
      yyvsp[-3].set->get_next ();
      len += strlen (yyvsp[-3].set->get_current ().get_value ().str) + 1;
    }				// end while
    char *temp = new char[strlen (yyvsp[-5].name) + 1 + len + 1 + 1 + strlen (yyvsp[0].val->str)];
    yyvsp[-3].set->init_curr_prev ();
    strcpy (temp, yyvsp[-5].name);
    strcat (temp, "(");
    strcat (temp, yyvsp[-3].set->get_current ().get_value ().str);
    while (!yyvsp[-3].set->end ()) {
      yyvsp[-3].set->get_next ();
      strcat (temp, ",");
      strcat (temp, yyvsp[-3].set->get_current ().get_value ().str);
    }				// end while
    strcat (temp, ")=");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-3].set->remove_all ();
    delete yyvsp[-3].set;
    delete[] yyvsp[-5].name;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    if (!syms->contains (yyvsp[-5].name)) {
      yyvsp[-3].set->remove_all ();
      delete[] yyvsp[-5].name;
      delete yyvsp[-3].set;
      yyvsp[0].val->free ();
      delete yyvsp[0].val;
      sp_error("Error, \"");
      sp_error(yyvsp[-5].name);
      sp_error("\" is not a defined matrix\n");
      YYERROR;
    }				// end if
    int type = syms->lookup (yyvsp[-5].name).get_value ().type;
    if (type == DENSE || type == SPARSE)
      yyval.val = set_element (yyvsp[-5].name, yyvsp[-3].set, yyvsp[0].val, err);
    delete[] yyvsp[-5].name;
    delete yyvsp[-3].set;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 45:
#line 1049 "spmath.y"
{
  if(text_flag) {
    char * temp = new char[strlen(yyvsp[-5].name) + 1 + strlen(yyvsp[-3].val->str) + 1 + 
			  strlen(yyvsp[-1].val->str) + 1];
    sprintf(temp, "%s(%s:%s)", yyvsp[-5].name, yyvsp[-3].val->str, yyvsp[-1].val->str);
    delete [] yyvsp[-5].name;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }
  else {
    int err = 0;
    yyval.val = get_range (yyvsp[-5].name, yyvsp[-3].val, new value(1), yyvsp[-1].val, err);
    delete[] yyvsp[-5].name;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if(err) {
      YYERROR;
    }
  }
;
    break;}
case 46:
#line 1077 "spmath.y"
{
  if(text_flag) {
    char * temp = new char[strlen(yyvsp[-7].name) + 1 + strlen(yyvsp[-5].val->str) + 1 + 
			  strlen(yyvsp[-3].val->str) + 1 + strlen(yyvsp[-1].val->str) + 1];
    sprintf(temp, "%s(%s:%s:%s)", yyvsp[-7].name, yyvsp[-5].val->str, yyvsp[-3].val->str, yyvsp[-1].val->str);
    delete [] yyvsp[-7].name;
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }
  else {
    int err = 0;
    yyval.val = get_range (yyvsp[-7].name, yyvsp[-5].val, yyvsp[-3].val, yyvsp[-1].val, err);
    delete[] yyvsp[-7].name;
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if(err) {
      YYERROR;
    }
  }
;
    break;}
case 47:
#line 1108 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 2 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, "||");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = _or (yyvsp[-2].val, yyvsp[0].val, err);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 48:
#line 1134 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 2 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, "&&");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = _and (yyvsp[-2].val, yyvsp[0].val, err);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end  else
;
    break;}
case 49:
#line 1160 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 1 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, "<");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = lt (yyvsp[-2].val, yyvsp[0].val, err);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 50:
#line 1186 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 2 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, "<=");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = le (yyvsp[-2].val, yyvsp[0].val, err);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 51:
#line 1212 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 2 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, "==");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = eq (yyvsp[-2].val, yyvsp[0].val, err);
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    yyvsp[-2].val->free ();
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 52:
#line 1238 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 2 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, ">=");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = ge (yyvsp[-2].val, yyvsp[0].val, err);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 53:
#line 1264 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 1 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, ">");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = gt (yyvsp[-2].val, yyvsp[0].val, err);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 54:
#line 1290 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 2 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, "!=");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = ne (yyvsp[-2].val, yyvsp[0].val, err);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 55:
#line 1316 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 1 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, "+");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = plus (yyvsp[-2].val, yyvsp[0].val, err);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 56:
#line 1342 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 1 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, "-");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = minus (yyvsp[-2].val, yyvsp[0].val, err);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 57:
#line 1368 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 1 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, "*");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = mult (yyvsp[-2].val, yyvsp[0].val, err);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 58:
#line 1394 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 2 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, ".*");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = emult (yyvsp[-2].val, yyvsp[0].val, err);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 59:
#line 1420 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 1 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, "/");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = div (yyvsp[-2].val, yyvsp[0].val, err);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 60:
#line 1446 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 2 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, "./");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = ediv (yyvsp[-2].val, yyvsp[0].val, err);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 63:
#line 1474 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, yyvsp[-1].val->str);
    strcat (temp, "'");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = transp (yyvsp[-1].val, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 64:
#line 1496 "spmath.y"
{
  if (text_flag)
    yyval.val = yyvsp[0].val;
  else
    yyval.val = yyvsp[0].val;
;
    break;}
case 65:
#line 1505 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[1 + strlen (yyvsp[0].val->str)];
    strcpy (temp, "-");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = uminus (yyvsp[0].val, err);
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 66:
#line 1526 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[2 + strlen (yyvsp[0].name)];
    strcpy (temp, "++");
    strcat (temp, yyvsp[0].name);
    yyval.val = new value (temp);
    delete[] yyvsp[0].name;
  }				// end if
  else {
    if (syms->contains (yyvsp[0].name)) {
      value temp (syms->lookup (yyvsp[0].name).get_value ());
      value tempvn (1);
      err = 0;
      yyval.val = plus (&temp, &tempvn, err);
      if (err)
	YYERROR;
      syms->insert (entry (yyvsp[0].name, *plus (&temp, &tempvn, err)));
    }				// end if
    else {
      sp_error("Error, undefined name: \"");
      sp_error(yyvsp[0].name);
      sp_error("\"\n");
      YYERROR;
    }				// end else
  }				// end else
;
    break;}
case 67:
#line 1555 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[2 + strlen (yyvsp[-1].name)];
    strcpy (temp, yyvsp[-1].name);
    strcat (temp, "++");
    yyval.val = new value (temp);
    delete[] yyvsp[-1].name;
  }				// end if
  else {
    if (syms->contains (yyvsp[-1].name)) {
      value temp (syms->lookup (yyvsp[-1].name).get_value ());
      value tempvn (1);
      yyval.val = new value (syms->lookup (yyvsp[-1].name).get_value ());
      if (yyval.val->type == NUM)
	yyval.val->num = (yyval.val->num);
      else if (yyval.val->type == DENSE)
	yyval.val->dmat = new dense (*yyval.val->dmat);
      else if (yyval.val->type == SPARSE)
	yyval.val->smat = new sparse (*yyval.val->smat);
      else if (yyval.val->type == STRING)
	yyval.val->str = strdup (yyval.val->str);
      else {
	sp_error ("Error, invalid type for operator ++\n");
	YYERROR;
      }				// end else
      err = 0;
      syms->insert (entry (yyvsp[-1].name, *plus (&temp, &tempvn, err)));
      if (err)
	YYERROR;

    }				// end if
    else {
      sp_error("Error, undefined name: \"");
      sp_error(yyvsp[-1].name);
      sp_error("\"\n");
      YYERROR;
    }				// end else
  }				// end else           
;
    break;}
case 68:
#line 1597 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[0].name) + 2];
    strcpy (temp, "--");
    strcat (temp, yyvsp[0].name);
    yyval.val = new value (temp);
    delete[] yyvsp[0].name;
  }				// end if
  else {
    if (syms->contains (yyvsp[0].name)) {
      value temp (syms->lookup (yyvsp[0].name).get_value ());
      value tempvn (1);
      err = 0;
      yyval.val = minus (&temp, &tempvn, err);
      if (err)
	YYERROR;
      syms->insert (entry (yyvsp[0].name, *minus (&temp, &tempvn, err)));
    }				// end if
    else {
      sp_error("Error, undefined name: \"");
      sp_error(yyvsp[0].name);
      sp_error("\"\n");
      YYERROR;
    }				// end else
  }				// end else
;
    break;}
case 69:
#line 1626 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-1].name) + 2];
    strcpy (temp, yyvsp[-1].name);
    strcpy (temp, "--");
    yyval.val = new value (temp);
    delete[] yyvsp[-1].name;
  }				// end if
  else {
    if (syms->contains (yyvsp[-1].name)) {
      value temp (syms->lookup (yyvsp[-1].name).get_value ());
      value tempvn (1);
      yyval.val = new value (syms->lookup (yyvsp[-1].name).get_value ());
      if (yyval.val->type == NUM)
	yyval.val->num = (yyval.val->num);
      else if (yyval.val->type == DENSE)
	yyval.val->dmat = new dense (*yyval.val->dmat);
      else if (yyval.val->type == SPARSE)
	yyval.val->smat = new sparse (*yyval.val->smat);
      else if (yyval.val->type == STRING)
	yyval.val->str = strdup (yyval.val->str);
      else {
	sp_error ("Error, invalid type for operator --\n");
	YYERROR;
      }				// end else
      err = 0;
      syms->insert (entry (yyvsp[-1].name, *minus (&temp, &tempvn, err)));
      if (err)
	YYERROR;

    }				// end if
    else {
      sp_error("Error, undefined name: \"");
      sp_error(yyvsp[-1].name);
      sp_error("\"\n");
      YYERROR;
    }				// end else
  }				// end else           
;
    break;}
case 70:
#line 1668 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[1 + strlen (yyvsp[0].val->str)];
    strcpy (temp, "!");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    delete[] yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = _not (yyvsp[0].val, err);
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 71:
#line 1688 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 1 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, "^");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = pow (yyvsp[-2].val, yyvsp[0].val, err);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 72:
#line 1714 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-2].val->str) + 2 + strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-2].val->str);
    strcat (temp, ".^");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = epow (yyvsp[-2].val, yyvsp[0].val, err);
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 73:
#line 1741 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, "(");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else
    yyval.val = yyvsp[-1].val;
;
    break;}
case 74:
#line 1757 "spmath.y"
{
  if (text_flag)
    yyval.val = new value (yyvsp[0].name);
  else {
    if (syms->contains (yyvsp[0].name)) {
      yyval.val = new value (syms->lookup (yyvsp[0].name).get_value ());
      if (yyval.val->type == NUM)
	yyval.val->num = (yyval.val->num);
      else if (yyval.val->type == DENSE)
	yyval.val->dmat = new dense (*yyval.val->dmat);
      else if (yyval.val->type == SPARSE)
	yyval.val->smat = new sparse (*yyval.val->smat);
      else if (yyval.val->type == STRING)
	yyval.val->str = strdup (yyval.val->str);
      else {
	sp_error ("Error, function name must be followed by arg list.\n");
	YYERROR;
      }				// end else
    }				// end if
    else {
      sp_error("Error, undefined name: \"");
      sp_error(yyvsp[0].name);
      sp_error("\"\n");
      YYERROR;
    }				// end else
  }				// end else  
;
    break;}
case 75:
#line 1785 "spmath.y"
{
  if (text_flag)
    yyval.val = yyvsp[0].val;
  else
    yyval.val = yyvsp[0].val;
;
    break;}
case 76:
#line 1792 "spmath.y"
{
  if (text_flag)
    yyval.val = yyvsp[0].val;
  else {
    yyval.val = yyvsp[0].val;
    unsigned int i;
    // Get rid of the quotation marks
    for (i = 0; i <= strlen (yyval.val->str); i += 1)
      *(yyval.val->str + i) = *(yyval.val->str + i + 1);
    *(yyval.val->str + strlen (yyval.val->str) - 1) = '\0';
  }				// end else
;
    break;}
case 77:
#line 1805 "spmath.y"
{
  if (text_flag)
    yyval.val = yyvsp[0].val;
  else
    yyval.val = yyvsp[0].val;
;
    break;}
case 78:
#line 1812 "spmath.y"
{
  if (text_flag)
    yyval.val = yyvsp[0].val;
  else
    yyval.val = yyvsp[0].val;
;
    break;}
case 79:
#line 1822 "spmath.y"
{
  // Send lex into "catch-all" mode
  my_yybegin(CATCH_MODE);   

  if (yychar == 0) {
    str_flag = 1;
    str = strdup ("$");
  }				// end if
  lk = yychar;
  yyclearin;
;
    break;}
case 80:
#line 1832 "spmath.y"
{
  int look = lk;
  if (text_flag) {
    yyvsp[-3].set->init_curr_prev ();
    int len = strlen (yyvsp[-3].set->get_current ().get_value ().str) + 1;
    while (!yyvsp[-3].set->end ()) {
      yyvsp[-3].set->get_next ();
      len += strlen (yyvsp[-3].set->get_current ().get_value ().str) + 1;
    }				// end while
    char *temp = new char[strlen (yyvsp[-5].name) + 1 + len + 1];
    yyvsp[-3].set->init_curr_prev ();
    strcpy (temp, yyvsp[-5].name);
    strcat (temp, "(");
    strcat (temp, yyvsp[-3].set->get_current ().get_value ().str);
    while (!yyvsp[-3].set->end ()) {
      yyvsp[-3].set->get_next ();
      strcat (temp, ",");
      strcat (temp, yyvsp[-3].set->get_current ().get_value ().str);
    }				// end while
    strcat (temp, ")");
    yychar = look;
    yyval.val = new value (temp);
    yyvsp[-3].set->remove_all ();
    delete yyvsp[-3].set;
    delete[] yyvsp[-5].name;
    delete[] yyvsp[0].name;
  }				// end if
  else {
    err = 0;
    if (syms->contains (yyvsp[-5].name)) {
      int type = syms->lookup (yyvsp[-5].name).get_value ().type;
      if (type == DENSE || type == SPARSE)
	yyval.val = get_element (yyvsp[-5].name, yyvsp[-3].set, err);
      else if (root.contains (yyvsp[-5].name)) {
	int type = root.lookup (yyvsp[-5].name).get_value ().type;
	if (type == FUNCT)
	  yyval.val = eval_funct (yyvsp[-5].name, yyvsp[-3].set, err);
      }				// end if
    }				// end if
    else {
      if (root.contains (yyvsp[-5].name)) {
	int type = root.lookup (yyvsp[-5].name).get_value ().type;
	if (type == FUNCT)
	  yyval.val = eval_funct (yyvsp[-5].name, yyvsp[-3].set, err);
      }				// end if
      else {
	yyvsp[-3].set->remove_all ();
	sp_error("Error, \"");
	sp_error(yyvsp[-5].name);
	sp_error("\" is not defined\n");
	delete[] yyvsp[-5].name;
	delete yyvsp[-3].set;
	YYERROR;
      }				// end else
    }				// end else
    delete[] yyvsp[-5].name;
    delete yyvsp[-3].set;
    if (err) {
      delete[] yyvsp[0].name;
      YYERROR;
    }				// end if
    char *temp = new char[8 + strlen (yyvsp[0].name)];
    if (look == SEMI)
      strcpy (temp, ";");
    if (look == COMMA)
      strcpy (temp, ",");
    if (look == ASSIGN)
      strcpy (temp, "=");
    if (look == OR)
      strcpy (temp, "||");
    if (look == AND)
      strcpy (temp, "&&");
    if (look == LT)
      strcpy (temp, "<");
    if (look == LE)
      strcpy (temp, "<=");
    if (look == EQ)
      strcpy (temp, "==");
    if (look == GE)
      strcpy (temp, ">=");
    if (look == GT)
      strcpy (temp, ">");
    if (look == NE)
      strcpy (temp, "!=");
    if (look == COLON)
      strcpy (temp, ":");
    if (look == PLUS)
      strcpy (temp, "+");
    if (look == MINUS)
      strcpy (temp, "-");
    if (look == MULT)
      strcpy (temp, "*");
    if (look == EMULT)
      strcpy (temp, ".*");
    if (look == DIV)
      strcpy (temp, "/");
    if (look == EDIV)
      strcpy (temp, "./");
    if (look == LDIV)
      strcpy (temp, "\\");
    if (look == ELDIV)
      strcpy (temp, ".\\");
    if (look == TRANSP)
      strcpy (temp, "'");
    if (look == UPLUS)
      strcpy (temp, "+");
    if (look == UMINUS)
      strcpy (temp, "-");
    if (look == INC)
      strcpy (temp, "++");
    if (look == DEC)
      strcpy (temp, "--");
    if (look == NOT)
      strcpy (temp, "!");
    if (look == POW)
      strcpy (temp, "^");
    if (look == EPOW)
      strcpy (temp, ".^");
    if (look == BREAK)
      strcpy (temp, "break");
    if (look == int ('('))
      strcpy (temp, "(");
    if (look == int (')'))
      strcpy (temp, ")");
    if (look == CONTINUE)
      strcpy (temp, "continue");
    if (look == ELSEIF)
      strcpy (temp, "elseif");
    if (look == END)
      strcpy (temp, "end");
    if (look == FOR)
      strcpy (temp, "for");
    if (look == FUNCTION)
      strcpy (temp, "function");
    if (look == GLOBAL)
      strcpy (temp, "global");
    if (look == IF)
      strcpy (temp, "if");
    if (look == RETURN)
      strcpy (temp, "return");
    if (look == WHILE)
      strcpy (temp, "while");
    strcat (temp, yyvsp[0].name);
    str_flag = 1;
    str = temp;
    delete[] yyvsp[0].name;
    yyrestart (yyin);
  }				// end else
;
    break;}
case 81:
#line 1982 "spmath.y"
{ 
  // Send lex into "catch-all" mode where it reads everything
  // up the next dollar sign and then returns it as a string
  // (without tokenizing it).
  my_yybegin(CATCH_MODE);   
  //yy_start = 1 + 2 * 1 
;
    break;}
case 82:
#line 1988 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[strlen (yyvsp[-4].name) + 1 + 1 + strlen (yyvsp[0].name)];
    strcpy (temp, yyvsp[-4].name);
    strcat (temp, "()");
    strcat (temp, yyvsp[0].name);
    yyval.val = new value (temp);
    delete[] yyvsp[-4].name;
    delete[] yyvsp[0].name;
  }				// end if
  else {
    err = 0;
    if (syms->contains (yyvsp[-4].name)) {
      //      int type = syms->lookup ($1).get_value ().type;
      if (root.contains (yyvsp[-4].name)) {
	int type = root.lookup (yyvsp[-4].name).get_value ().type;
	if (type == FUNCT)
	  yyval.val = eval_funct (yyvsp[-4].name, new list (), err);
      }				// end if
    }				// end if
    else {
      if (root.contains (yyvsp[-4].name)) {
	int type = root.lookup (yyvsp[-4].name).get_value ().type;
	if (type == FUNCT)
	  yyval.val = eval_funct (yyvsp[-4].name, new list (), err);
      }				// end if
      else {
	sp_error("Error, \"");
	sp_error(yyvsp[-4].name);
	sp_error("\" is not defined\n");
	delete[] yyvsp[-4].name;
	delete[] yyvsp[0].name;
	YYERROR;
      }				// end else
    }				// end else
    delete[] yyvsp[-4].name;
    if (err) {
      delete[] yyvsp[0].name;
      YYERROR;
    }				// end if
    str_flag = 1;
    str = yyvsp[0].name;
    yyrestart (yyin);
  }				// end else

;
    break;}
case 83:
#line 2035 "spmath.y"
{ 
  // Send lex into "catch-all" mode where it reads everything
  // up the next dollar sign and then returns it as a string
  // (without tokenizing it).
  my_yybegin(CATCH_MODE);   
  //  yy_start = 1 + 2 * 1 
;
    break;}
case 84:
#line 2041 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[0].name)];
    strcpy (temp, "load(");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ")");
    strcat (temp, yyvsp[0].name);
    yyval.val = new value (temp);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    delete[] yyvsp[0].name;
  }				// end if
  else {
    err = 0;
    yyval.val = load (yyvsp[-3].val, 1, err);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    if (err) {
      delete[] yyvsp[0].name;
      YYERROR;
    }				// end if
    str_flag = 1;
    str = yyvsp[0].name;
    yyrestart (yyin);
  }				// end else
;
    break;}
case 85:
#line 2068 "spmath.y"
{ 
  // Send lex into "catch-all" mode where it reads everything
  // up the next dollar sign and then returns it as a string
  // (without tokenizing it).
  my_yybegin(CATCH_MODE);   
  //  yy_start = 1 + 2 * 1 
;
    break;}
case 86:
#line 2074 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[0].name)];
    strcpy (temp, "demo(");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ")");
    strcat (temp, yyvsp[0].name);
    yyval.val = new value (temp);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    delete[] yyvsp[0].name;
  }				// end if
  else {
    err = 0;
    yyval.val = load (yyvsp[-3].val, 1, err);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    if (err) {
      delete[] yyvsp[0].name;
      YYERROR;
    }				// end if
    str_flag = 1;
    str = yyvsp[0].name;
    yyrestart (yyin);
  }				// end else
;
    break;}
case 87:
#line 2101 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[6 + strlen (yyvsp[-2].name) + 1 + strlen (yyvsp[0].val->str)];
    strcpy (temp, "alias ");
    strcat (temp, yyvsp[-2].name);
    strcat (temp, "=");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    delete[] yyvsp[-2].name;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    if (yyvsp[0].val->type == STRING) {
      ali->insert (entry (yyvsp[-2].name, *yyvsp[0].val));
      yyvsp[0].val->str = strdup (yyvsp[0].val->str);
    }
    else {
      sp_error("Error, invalid type for operator assign.\n");
      YYERROR;
    }				// end else
    yyval.val = yyvsp[0].val;
  }				// end else
;
    break;}
case 88:
#line 2127 "spmath.y"
{ 
  // Send lex into "catch-all" mode where it reads everything
  // up the next dollar sign and then returns it as a string
  // (without tokenizing it).
  //  cout << "Entering catch mode" << endl;
  my_yybegin(CATCH_MODE);   
  //  yy_start = 1 + 2 * 1 
;
    break;}
case 89:
#line 2134 "spmath.y"
{
  assert (yyvsp[0].name[strlen (yyvsp[0].name) - 1] == '$');
  yyvsp[0].name[strlen (yyvsp[0].name) - 1] = '\0';
  help (yyvsp[0].name);
  str_flag = 1;
  str = strdup ("$");
  yyval.val = new value ();
;
    break;}
case 90:
#line 2143 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "nrow(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    if (yyvsp[-1].val->type == DENSE)
      yyval.val = new value (yyvsp[-1].val->dmat->get_nrow ());
    else if (yyvsp[-1].val->type == SPARSE)
      yyval.val = new value (yyvsp[-1].val->smat->get_nrow ());
    else
      yyval.val = new value (0);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end else
;
    break;}
case 91:
#line 2165 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "ncol(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    if (yyvsp[-1].val->type == DENSE)
      yyval.val = new value (yyvsp[-1].val->dmat->get_ncol ());
    else if (yyvsp[-1].val->type == SPARSE)
      yyval.val = new value (yyvsp[-1].val->smat->get_ncol ());
    else
      yyval.val = new value (0);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end else
;
    break;}
case 92:
#line 2187 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[3 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "nnz(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    if (yyvsp[-1].val->type == DENSE)
      yyval.val = new value (yyvsp[-1].val->dmat->get_nnz ());
    else if (yyvsp[-1].val->type == SPARSE)
      yyval.val = new value (yyvsp[-1].val->smat->get_nnz ());
    else
      yyval.val = new value (0);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end else
;
    break;}
case 93:
#line 2209 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "size(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    if (yyvsp[-1].val->type == DENSE) {
      if (yyvsp[-1].val->dmat->get_nrow () == 1) {
	yyval.val = new value (yyvsp[-1].val->dmat->get_ncol ());
      }
      else {
	dense *dtemp = new dense (1, 2);
	dtemp->set_element (1, 1, yyvsp[-1].val->dmat->get_nrow ());
	dtemp->set_element (1, 2, yyvsp[-1].val->dmat->get_ncol ());
	yyval.val = new value (dtemp);
      }
    }
    if (yyvsp[-1].val->type == SPARSE) {
      if (yyvsp[-1].val->smat->get_nrow () == 1) {
	yyval.val = new value (yyvsp[-1].val->smat->get_ncol ());
      }
      else {
	dense *temp = new dense (1, 2);
	temp->set_element (1, 1, yyvsp[-1].val->smat->get_nrow ());
	temp->set_element (1, 2, yyvsp[-1].val->smat->get_ncol ());
	yyval.val = new value (temp);
      }
    }
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end else
;
    break;}
case 94:
#line 2247 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[3 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "eye(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = eye (yyvsp[-1].val, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      sp_error("Error while creating identity matrix\n");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 95:
#line 2269 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[8 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "spzeroes(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = spzeroes (yyvsp[-1].val, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 96:
#line 2290 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[8 + 1 + strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "spzeroes(");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = spzeroes (yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 97:
#line 2318 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[6 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "zeroes(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = zeroes (yyvsp[-1].val, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 98:
#line 2339 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[6 + 1 + strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "zeroes(");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = zeroes (yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 99:
#line 2367 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "ones(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = ones (yyvsp[-1].val, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 100:
#line 2388 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[4 + 1 + strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "ones(");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = ones (yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 101:
#line 2416 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[8 + 1 + strlen (yyvsp[-5].val->str) + 1 + strlen (yyvsp[-3].val->str) + 1 +
	       strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "constmat(");
    strcat (temp, yyvsp[-5].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = init (yyvsp[-5].val, yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 102:
#line 2450 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[5 + 1 + strlen (yyvsp[-1].name) + 1];
    strcpy (temp, "clear(");
    strcat (temp, yyvsp[-1].name);
    strcat (temp, ")");
    yyval.val = new value (temp);
    delete[] yyvsp[-1].name;
  }				// end if
  else {
    if (syms->contains (yyvsp[-1].name))
      syms->remove (yyvsp[-1].name);
    if (ali->contains (yyvsp[-1].name)) {
      ali->remove (yyvsp[-1].name);
    }
    clear_alias = 0;
  }
;
    break;}
case 103:
#line 2469 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[5 + strlen (yyvsp[0].name)];
    strcpy (temp, "clear(");
    strcat (temp, yyvsp[0].name);
    strcat (temp, ")");
    yyval.val = new value (temp);
    delete[] yyvsp[0].name;
  }				// end if
  else {
    if (syms->contains (yyvsp[0].name))
      syms->remove (yyvsp[0].name);
    if (ali->contains (yyvsp[0].name)) {
      ali->remove (yyvsp[0].name);
    }
    clear_alias = 0;
  }
;
    break;}
case 104:
#line 2488 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "hbin(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = readmt (yyvsp[-1].val, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 105:
#line 2512 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[6 + 1 + strlen (yyvsp[-9].val->str) + 1 + strlen (yyvsp[-7].val->str) + 1 +
	       strlen (yyvsp[-5].val->str) + 1 + strlen (yyvsp[-3].val->str) + 1 +
	       strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "submat(");
    strcat (temp, yyvsp[-9].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-7].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-5].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-9].val->free ();
    delete yyvsp[-9].val;
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = submat (yyvsp[-9].val, yyvsp[-7].val, yyvsp[-5].val, yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-9].val->free ();
    delete yyvsp[-9].val;
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else

;
    break;}
case 106:
#line 2560 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[7 + 1 + strlen (yyvsp[-5].val->str) + 1 + strlen (yyvsp[-3].val->str) + 1 +
	       strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "extract(");
    strcat (temp, yyvsp[-5].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    if (yyvsp[-5].val->type == DENSE) {
      if (yyvsp[-5].val->dmat->get_nrow () == 1)
	yyval.val = submat (new value (1), new value (1), yyvsp[-3].val, yyvsp[-1].val, yyvsp[-5].val, err);
    }
    else {
      yyerror ("Error, the first argument must be a vector");
      err = 1;
    }
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 107:
#line 2601 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[11 + 1 + strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "extract_row(");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    if (yyvsp[-3].val->type == DENSE)
      yyval.val =
	submat (yyvsp[-1].val, yyvsp[-1].val, new value (1), new value (yyvsp[-3].val->dmat->get_ncol ()), yyvsp[-3].val,
		err);
    if (yyvsp[-3].val->type == SPARSE)
      yyval.val =
	submat (yyvsp[-1].val, yyvsp[-1].val, new value (1), new value (yyvsp[-3].val->smat->get_ncol ()), yyvsp[-3].val,
		err);
    yyvsp[-3].val->free ();
    delete[] yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;

    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 108:
#line 2636 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[11 + 1 + strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "extract_col(");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    if (yyvsp[-3].val->type == DENSE)
      yyval.val =
	submat (new value (1), new value (yyvsp[-3].val->dmat->get_nrow ()), yyvsp[-1].val, yyvsp[-1].val, yyvsp[-3].val,
		err);
    if (yyvsp[-3].val->type == SPARSE)
      yyval.val =
	submat (new value (1), new value (yyvsp[-3].val->smat->get_nrow ()), yyvsp[-1].val, yyvsp[-1].val, yyvsp[-3].val,
		err);
    if (yyvsp[-3].val->type != DENSE && yyvsp[-3].val->type != SPARSE) {
      yyerror
	("Error, the 1st argument must be either a sparse or a dense matrix. ");
      err = 1;
    }
    yyvsp[-3].val->free ();
    delete[] yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;

    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 109:
#line 2676 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[6 + 1 + strlen (yyvsp[-7].val->str) + 1 + strlen (yyvsp[-5].val->str) + 1 +
	       strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "filter(");
    strcat (temp, yyvsp[-7].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-5].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = filter (yyvsp[-7].val, yyvsp[-5].val, yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;

    if (err)
      YYERROR;
  }				// end else

;
    break;}
case 110:
#line 2718 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[5 + 1 + strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "csort(");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = csort (yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-3].val->free ();
    delete[] yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;

    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 111:
#line 2746 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[5 + 1 + strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "rmdia(");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = rmdia (yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-3].val->free ();
    delete[] yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;

    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 112:
#line 2774 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[6 + 1 + strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "getdia(");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = getdia (yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-3].val->free ();
    delete[] yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;

    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 113:
#line 2802 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "getu(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = getu (yyvsp[-1].val, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 114:
#line 2822 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "getl(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = getl (yyvsp[-1].val, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 115:
#line 2842 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[6 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "getbwd(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = getbwd (yyvsp[-1].val, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 116:
#line 2862 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[7 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "getbwdu(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = getbwdu (yyvsp[-1].val, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 117:
#line 2882 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[7 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "getbwdl(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = getbwdl (yyvsp[-1].val, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 118:
#line 2902 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[6 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "blkfnd(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = blkfnd (yyvsp[-1].val, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 119:
#line 2923 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[5 + 1 + strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "cnrms(");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = cnrms (yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-3].val->free ();
    delete[] yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;

    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 120:
#line 2951 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[6 + 1 + strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "coscal(");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = coscal (yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-3].val->free ();
    delete[] yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;

    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 121:
#line 2979 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[6 + 1 + strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "roscal(");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = roscal (yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-3].val->free ();
    delete[] yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;

    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 122:
#line 3007 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[6 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "get1up(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = get1up (yyvsp[-1].val, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 123:
#line 3027 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[6 + 1 + strlen (yyvsp[-7].val->str) + 1 + strlen (yyvsp[-5].val->str) + 1 +
	       strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "addblk(");
    strcat (temp, yyvsp[-7].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-5].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = addblk (yyvsp[-7].val, yyvsp[-5].val, yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;

    if (err)
      YYERROR;
  }				// end else

;
    break;}
case 124:
#line 3073 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[5 + 1 + strlen (yyvsp[-7].val->str) + 1 + strlen (yyvsp[-5].val->str) + 1 +
	       strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "fdmat(");
    strcat (temp, yyvsp[-7].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-5].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = gen57pt (yyvsp[-7].val, yyvsp[-5].val, yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 125:
#line 3114 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[6 + 1 + strlen (yyvsp[-19].val->str) + 1 + strlen (yyvsp[-17].val->str) + 1 +
	       strlen (yyvsp[-15].val->str) + 1 + strlen (yyvsp[-13].val->str) + 1 +
	       strlen (yyvsp[-11].val->str) + 1 + strlen (yyvsp[-9].val->str) + 1 +
	       strlen (yyvsp[-7].val->str) + 1 + strlen (yyvsp[-5].val->str) + 1 +
	       strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];

    strcpy (temp, "fdmat(");
    strcat (temp, yyvsp[-19].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-17].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-15].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-13].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-11].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-9].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-7].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-5].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");

    yyval.val = new value (temp);
    yyvsp[-19].val->free ();
    delete yyvsp[-19].val;
    yyvsp[-17].val->free ();
    delete yyvsp[-17].val;
    yyvsp[-15].val->free ();
    delete yyvsp[-15].val;
    yyvsp[-13].val->free ();
    delete yyvsp[-13].val;
    yyvsp[-11].val->free ();
    delete yyvsp[-11].val;
    yyvsp[-9].val->free ();
    delete yyvsp[-9].val;
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val =
      solve_system (yyvsp[-19].val, yyvsp[-17].val, yyvsp[-15].val, yyvsp[-13].val, yyvsp[-11].val, yyvsp[-9].val, yyvsp[-7].val, yyvsp[-5].val, yyvsp[-3].val, yyvsp[-1].val, err);

    yyvsp[-19].val->free ();
    delete yyvsp[-19].val;
    yyvsp[-17].val->free ();
    delete yyvsp[-17].val;
    yyvsp[-15].val->free ();
    delete yyvsp[-15].val;
    yyvsp[-13].val->free ();
    delete yyvsp[-13].val;
    yyvsp[-11].val->free ();
    delete yyvsp[-11].val;
    yyvsp[-9].val->free ();
    delete yyvsp[-9].val;
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 126:
#line 3197 "spmath.y"
{

  if (text_flag) {
    char *temp =
      new char[5 + 1 + strlen (yyvsp[-5].val->str) + 1 + strlen (yyvsp[-3].val->str) + 1 +
	      strlen (yyvsp[-1].val->str) + 1];

    strcpy (temp, "fdmat(");
    strcat (temp, yyvsp[-5].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");

    yyval.val = new value (temp);
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = solve_system (yyvsp[-5].val, yyvsp[-3].val, yyvsp[-1].val, err);

    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 127:
#line 3235 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[6 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "multic(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ",");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = multic (yyvsp[-1].val, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 128:
#line 3255 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[6 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "colors(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ",");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = colors (yyvsp[-1].val, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 129:
#line 3275 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[8 + 1 + strlen (yyvsp[-5].val->str) + 1 + strlen (yyvsp[-3].name) + 1 + strlen (yyvsp[-1].name) +
	       1];
    strcpy (temp, "colorset(");
    strcat (temp, yyvsp[-5].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-3].name);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].name);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    delete [] yyvsp[-3].name;
    delete [] yyvsp[-1].name;
  }
  else {
    err = 0;
    value *b = il_multic (yyvsp[-5].val, err);
    if (err) {
      yyvsp[-5].val->free();
      delete yyvsp[-5].val;
      delete [] yyvsp[-3].name;
      delete [] yyvsp[-1].name;
      YYERROR;
    }
    syms->insert (entry (strdup(yyvsp[-3].name), *b));

    value *c = iord_multic (yyvsp[-5].val, err);
    if (err) {
      yyvsp[-5].val->free();
      delete yyvsp[-5].val;
      delete [] yyvsp[-3].name;
      delete [] yyvsp[-1].name;
      YYERROR;
    }
    syms->insert (entry (strdup(yyvsp[-1].name), *c));

    several_init = 0;
    yyval.val = new value ();

    sp_out(yyvsp[-3].name);
    sp_out(" now contains the pointers to the beginning of each color set\n");
    sp_out(yyvsp[-1].name);
    sp_out(" now contains the permutation array\n");

    yyvsp[-5].val->free();
    delete yyvsp[-5].val;
    delete [] yyvsp[-3].name;
    delete [] yyvsp[-1].name;
    YYERROR;
  }
;
    break;}
case 130:
#line 3331 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[7 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "indset0(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ",");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = indset0 (yyvsp[-1].val, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 131:
#line 3351 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[7 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "indset1(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ",");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = indset1 (yyvsp[-1].val, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 132:
#line 3372 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[7 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "colors2(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ",");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    int nco = 0;
    yyval.val = colors2 (yyvsp[-1].val, err, nco);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    //    cout << "number of colors: " << nco << "\n";
    sp_out("number of colors: "); sp_out(nco); sp_out("\n");
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 133:
#line 3397 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[5 + 1 + strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "hbout(");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = prtmt (yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 134:
#line 3424 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[5 + 1 + strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "rperm(");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = rperm (yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 135:
#line 3451 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[5 + 1 + strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "cperm(");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = cperm (yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 136:
#line 3478 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[5 + 1 + strlen (yyvsp[-5].val->str) + 1 + strlen (yyvsp[-3].val->str) + 1 +
	       strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "dperm(");
    strcat (temp, yyvsp[-5].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = dperm (yyvsp[-5].val, yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 137:
#line 3513 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[3 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "sin(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, sin, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function sin.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 138:
#line 3535 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "sqrt(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, sqrt, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function sqrt.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 139:
#line 3557 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[3 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "cos(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, cos, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function cos.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 140:
#line 3579 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[3 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "tan(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, tan, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function tan.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 141:
#line 3601 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[3 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "cot(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, cot, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function cot.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 142:
#line 3623 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[2 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "sec(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, sec, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function sec.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 143:
#line 3645 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[3 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "csc(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, csc, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function csc.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 144:
#line 3667 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "asin(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, asin, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function asin.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 145:
#line 3689 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "acos(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, acos, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function acos.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 146:
#line 3711 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "atan(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, atan, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function atan.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 147:
#line 3733 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "acot(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, acot, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function acot.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 148:
#line 3755 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "asec(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, asec, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function asec.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 149:
#line 3777 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "acsc(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, acsc, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function acsc.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 150:
#line 3799 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[3 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "exp(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, exp, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function exp.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 151:
#line 3821 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[3 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "log(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, log, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function log.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 152:
#line 3843 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[5 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "log10(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, log10, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function log10.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 153:
#line 3865 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[3 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "abs(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, fabs, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function abs.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 154:
#line 3887 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "ceil(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, ceil, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function ceil.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 155:
#line 3909 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[5 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "floor(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, floor, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function floor.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 156:
#line 3931 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[5 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "round(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, round, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function round.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 157:
#line 3953 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[5 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "trunc(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = function (yyvsp[-1].val, trunc, err);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function trunc.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 158:
#line 3975 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "rand(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = new value (rnd0nb ((int) yyvsp[-1].val->num, 0.0));
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function rand.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 159:
#line 3997 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[4 + 1 + strlen (yyvsp[-5].val->str) + 1 + strlen (yyvsp[-3].val->str) + 1 +
	       strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "rand(");
    strcat (temp, yyvsp[-5].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = rando (yyvsp[-5].val, yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function rand.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 160:
#line 4033 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[4 + 1 + strlen (yyvsp[-7].val->str) + 1 + strlen (yyvsp[-5].val->str) + 1 +
	       strlen (yyvsp[-3].val->str) + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "rand(");
    strcat (temp, yyvsp[-7].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-5].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-3].val->str);
    strcat (temp, ",");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    err = 0;
    yyval.val = rando (yyvsp[-7].val, yyvsp[-5].val, yyvsp[-3].val, yyvsp[-1].val, err);
    yyvsp[-7].val->free ();
    delete yyvsp[-7].val;
    yyvsp[-5].val->free ();
    delete yyvsp[-5].val;
    yyvsp[-3].val->free ();
    delete yyvsp[-3].val;
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
    if (err) {
      yyerror ("Error, invalid type for function rand.");
      YYERROR;
    }				// end if
  }				// end else
;
    break;}
case 161:
#line 4076 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[4 + 1 + 1];
    strcpy (temp, "rand()");
    yyval.val = new value (temp);
  }				// end if
  else
    yyval.val = new value (rnd (0.0));
;
    break;}
case 162:
#line 4086 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[5 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "irand(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
  }				// end if
  else
    yyval.val = new value (irnd ((int) yyvsp[-1].val->num, 0.0));
;
    break;}
case 163:
#line 4099 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[5 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "dense(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    if (yyvsp[-1].val->type == DENSE)
      yyval.val = yyvsp[-1].val;
    else {
      if (yyvsp[-1].val->type == SPARSE) {
	yyval.val = new value (new dense (*yyvsp[-1].val->smat));
	yyvsp[-1].val->free ();
      }				// end if
      else {
	yyerror ("Error, invalid type for function dense.");
	YYERROR;
      }				// end else
    }				// end else
  }				// end else
;
    break;}
case 164:
#line 4125 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[6 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "sparse(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    if (yyvsp[-1].val->type == SPARSE)
      yyval.val = yyvsp[-1].val;
    else {
      if (yyvsp[-1].val->type == DENSE) {
	yyval.val =
	  new value (new
		     sparse (yyvsp[-1].val->dmat->get_nrow (), yyvsp[-1].val->dmat->get_ncol (),
			     yyvsp[-1].val->dmat->get_pointer ()));
	yyvsp[-1].val->free ();
      }				// end if
      else {
	yyerror ("Error, invalid type for function sparse.");
	YYERROR;
      }				// end else
    }				// end else
  }				// end else
;
    break;}
case 165:
#line 4154 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[9 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "is_number(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    if (yyvsp[-1].val->type == NUM)
      yyval.val = new value (1);
    else
      yyval.val = new value (0);
  }				// end else
;
    break;}
case 166:
#line 4172 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[8 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "is_dense(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    if (yyvsp[-1].val->type == DENSE)
      yyval.val = new value (1);
    else
      yyval.val = new value (0);
  }				// end else
;
    break;}
case 167:
#line 4190 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[9 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "is_sparse(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    if (yyvsp[-1].val->type == SPARSE)
      yyval.val = new value (1);
    else
      yyval.val = new value (0);
  }				// end else
;
    break;}
case 168:
#line 4208 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[9 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "is_string(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    if (yyvsp[-1].val->type == STRING)
      yyval.val = new value (1);
    else
      yyval.val = new value (0);
  }				// end else
;
    break;}
case 169:
#line 4226 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[9 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "is_vector(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    yyval.val = new value (0);
    if (yyvsp[-1].val->type == DENSE) {
      if (yyvsp[-1].val->dmat->get_nrow () == 1 || yyvsp[-1].val->dmat->get_ncol () == 1)
	yyval.val = new value (1);
    }				// end if
    if (yyvsp[-1].val->type == SPARSE) {
      if (yyvsp[-1].val->smat->get_nrow () == 1 || yyvsp[-1].val->smat->get_ncol () == 1)
	yyval.val = new value (1);
    }				// end if
  }				// end else
;
    break;}
case 170:
#line 4249 "spmath.y"
{
  if (text_flag) {
    char *temp = new char[7 + 1 + strlen (yyvsp[-1].val->str) + 1];
    strcpy (temp, "what_is(");
    strcat (temp, yyvsp[-1].val->str);
    strcat (temp, ")");
    yyval.val = new value (temp);
    yyvsp[-1].val->free ();
    delete yyvsp[-1].val;
  }				// end if
  else {
    if (yyvsp[-1].val->type == NUM) {
      //      cout << "scalar: " << $3->num << "\n";
      sp_out("scalar: "); sp_out(yyvsp[-1].val->num); sp_out("\n");
      yyval.val = new value ();
    }
    else {
      if (yyvsp[-1].val->type == STRING) {
	//	cout << "string: " << $3->str << "\n";
	sp_out("string: "); sp_out(yyvsp[-1].val->str); sp_out("\n");
	yyval.val = new value ();
      }
      else {
	if (yyvsp[-1].val->type == SPARSE) {
	  int nrow = yyvsp[-1].val->smat->get_nrow();
	  int ncol = yyvsp[-1].val->smat->get_ncol();
	  //	  cout << "sparse matrix of size: " << nrow << " x " 
	  //	       << ncol << "\n";
	  sp_out("sparse matrix of size: "); sp_out(nrow);
	  sp_out(" x "); sp_out(ncol); sp_out("\n");
						    
	  yyval.val = new value ();	 
	}
	else {
	  if (yyvsp[-1].val->type == DENSE) {
	    int ncol = yyvsp[-1].val->dmat->get_ncol();
	    int nrow = yyvsp[-1].val->dmat->get_nrow();
	    if (yyvsp[-1].val->dmat->get_nrow () == 1) {
	      //	      cout << "vector of size: " << ncol << "\n";
	      sp_out("vector of size: "); sp_out(ncol);
	      sp_out("\n");
	    }
	    else {
	      if (yyvsp[-1].val->dmat->get_ncol () == 1) {
		//		cout << "vector of size: " << nrow << "\n";
		sp_out("vector of size: "); sp_out(nrow);
		sp_out("\n");
	      }
	      else {
		//		cout << "dense matrix of size: " << nrow << " x " 
		//		     << ncol << "\n";
		sp_out("dense matrix of size: "); sp_out(nrow);
		sp_out(" x "); sp_out(ncol); sp_out("\n");
	      }
	    }
	    yyval.val = new value ();
	  }
	  else {
	    //	    cout << "unknown\n";
	    sp_out("unknown\n");
	    yyval.val = new value ();
	  }
	}
      }
    }
  }				// end else
;
    break;}
case 171:
#line 4317 "spmath.y"
{
  if(text_flag) {
    char *temp = new char[4 + 1 + strlen(yyvsp[-1].val->str) + 1];
    sprintf(temp, "type(%s)", yyvsp[-1].val->str);
    yyval.val = new value(temp);
    yyvsp[-1].val->free();
    delete yyvsp[-1].val;
  }
  else {
    yyval.val = spit_file(yyvsp[-1].val->str);
  }
;
    break;}
case 172:
#line 4330 "spmath.y"
{
  
#ifndef NO_TK_COMPILE

  if(text_flag) {
    char *temp = new char[3 + 1 + strlen(yyvsp[-1].val->str) + 1];
    sprintf(temp, "spy(%s)", yyvsp[-1].val->str);
    yyval.val = new value(temp); 
    yyvsp[-1].val->free();
    delete yyvsp[-1].val;
  }
  else {
    if(no_tk) {
      sp_error("view command not implemented in non-tk mode...\n"
	       "please restart spmath without the -notk option to use view");
      YYERROR;
    }
    if(cur_spyview > MAX_VIEWS) {
      sp_error("too many views open at once");
      YYERROR;
    }
    if(yyvsp[-1].val->type == SPARSE) {
      if(yyvsp[-1].val->smat->get_nrow() != yyvsp[-1].val->smat->get_ncol()) {
	yyerror("Error, matrix parameter to view must be square");
	YYERROR;
      }
      spyviews[cur_spyview] = new view(*yyvsp[-1].val->smat);
    }
    else if(yyvsp[-1].val->type == DENSE) {
      if(yyvsp[-1].val->dmat->get_nrow() != yyvsp[-1].val->dmat->get_ncol()) {
	yyerror("Error, matrix parameter to view must be square");
	YYERROR;
      }
      spyviews[cur_spyview] = new view(*yyvsp[-1].val->dmat);
    }
    else {
      sp_error("parameter to view(...) must be a matrix");
      YYERROR;
    }
    spyviews[cur_spyview]->create();
    cur_spyview++;
    yyval.val = new value();
    yyvsp[-1].val->free();
    delete yyvsp[-1].val;
  }

#else

  sp_error("view command not implemented in non-tk version...\n");
  
  yyval.val = new value();
  yyvsp[-1].val->free();
  delete yyvsp[-1].val;
  
#endif

;
    break;}
case 173:
#line 4392 "spmath.y"
{
  if (text_flag) {
    yyvsp[-1].set->init_curr_prev ();
    int len = strlen (yyvsp[-1].set->get_current ().get_value ().str);
    while (!yyvsp[-1].set->end ()) {
      yyvsp[-1].set->get_next ();
      len += strlen (yyvsp[-1].set->get_current ().get_value ().str);
    }				// end while
    char *temp = new char[len + 2];
    yyvsp[-1].set->init_curr_prev ();
    strcpy (temp, "[");
    strcat (temp, yyvsp[-1].set->get_current ().get_value ().str);
    while (!yyvsp[-1].set->end ()) {
      yyvsp[-1].set->get_next ();
      strcat (temp, yyvsp[-1].set->get_current ().get_value ().str);
    }				// end while
    strcat (temp, "]");
    yyvsp[-1].set->remove_all ();
    delete yyvsp[-1].set;
    yyval.val = new value (temp);
  }				// end if
  else {
    err = 0;
    yyval.val = process_dense_row_list (yyvsp[-1].set, err);
    delete yyvsp[-1].set;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 174:
#line 4422 "spmath.y"
{
  yyval.val = yyvsp[0].val;
;
    break;}
case 175:
#line 4429 "spmath.y"
{
  yyvsp[0].set->push (entry (strdup (""), *yyvsp[-1].val));
  yyval.set = yyvsp[0].set;
  delete yyvsp[-1].val;
;
    break;}
case 176:
#line 4435 "spmath.y"
{
  yyval.set = new list;
  yyval.set->push (entry (strdup (""), *yyvsp[0].val));
  delete yyvsp[0].val;
;
    break;}
case 177:
#line 4443 "spmath.y"
{
  if (text_flag) {
    yyvsp[-1].set->init_curr_prev ();
    int len = strlen (yyvsp[-1].set->get_current ().get_value ().str) + 1;
    while (!yyvsp[-1].set->end ()) {
      yyvsp[-1].set->get_next ();
      len += strlen (yyvsp[-1].set->get_current ().get_value ().str) + 1;
    }				// end while
    char *temp = new char[len + 1];
    yyvsp[-1].set->init_curr_prev ();
    strcpy (temp, yyvsp[-1].set->get_current ().get_value ().str);
    while (!yyvsp[-1].set->end ()) {
      yyvsp[-1].set->get_next ();
      strcat (temp, ",");
      strcat (temp, yyvsp[-1].set->get_current ().get_value ().str);
    }				// end while
    yyvsp[-1].set->remove_all ();
    delete yyvsp[-1].set;
    strcat (temp, ";");
    yyval.val = new value (temp);
  }				// end if
  else {
    err = 0;
    yyval.val = process_comma_list (yyvsp[-1].set, err);
    delete yyvsp[-1].set;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 178:
#line 4475 "spmath.y"
{
  if (text_flag) {
    yyvsp[0].set->init_curr_prev ();
    int len = strlen (yyvsp[0].set->get_current ().get_value ().str) + 1;
    while (!yyvsp[0].set->end ()) {
      yyvsp[0].set->get_next ();
      len += strlen (yyvsp[0].set->get_current ().get_value ().str) + 1;
    }				// end while
    char *temp = new char[len];
    yyvsp[0].set->init_curr_prev ();
    strcpy (temp, yyvsp[0].set->get_current ().get_value ().str);
    while (!yyvsp[0].set->end ()) {
      yyvsp[0].set->get_next ();
      strcat (temp, ",");
      strcat (temp, yyvsp[0].set->get_current ().get_value ().str);
    }				// end while
    yyvsp[0].set->remove_all ();
    delete yyvsp[0].set;
    yyval.val = new value (temp);
  }				// end if
  else {
    err = 0;
    yyval.val = process_comma_list (yyvsp[0].set, err);
    delete yyvsp[0].set;
    if (err)
      YYERROR;
  }				// end else
;
    break;}
case 179:
#line 4508 "spmath.y"
{
  yyvsp[0].set->push (entry (strdup (""), *yyvsp[-2].val));
  yyval.set = yyvsp[0].set;
  delete yyvsp[-2].val;
;
    break;}
case 180:
#line 4514 "spmath.y"
{
  yyval.set = new list;
  yyval.set->push (entry (strdup (""), *yyvsp[0].val));
  delete yyvsp[0].val;
;
    break;}
case 181:
#line 4523 "spmath.y"
{
  if (text_flag) {
    char *temp =
      new char[strlen (yyvsp[-4].val->str) + 1 + strlen (yyvsp[-2].val->str) + 1 +
	       strlen (yyvsp[0].val->str)];
    strcpy (temp, yyvsp[-4].val->str);
    strcat (temp, ":");
    strcat (temp, yyvsp[-2].val->str);
    strcat (temp, ":");
    strcat (temp, yyvsp[0].val->str);
    yyval.val = new value (temp);
    yyvsp[-4].val->free ();
    delete yyvsp[-4].val;
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
  }				// end if
  else {
    err = 0;
    yyval.val = vec (yyvsp[-4].val, yyvsp[-2].val, yyvsp[0].val, err);
    yyvsp[-4].val->free ();
    delete yyvsp[-4].val;
    yyvsp[-2].val->free ();
    delete yyvsp[-2].val;
    yyvsp[0].val->free ();
    delete yyvsp[0].val;
    if (err)
      YYERROR;
  }				// end else   
;
    break;}
case 182:
#line 4561 "spmath.y"
{
  text_flag += 1;
;
    break;}
case 183:
#line 4568 "spmath.y"
{
  text_flag -= 1;
;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 4580 "spmath.y"


//
// sp_init()
//  
//  Prepares the spmath environment: inserts useful
// constants into the global sym table and prints out
// a welcome message.
//
void sp_init ()
{
  char buf[256];

  // Insert some useful constants into the symbol table.

  syms->insert (entry (strdup ("true"), value (1)));
  syms->insert (entry (strdup ("false"), value (0)));
  syms->insert (entry (strdup ("pi"), value (3.1415926535)));
  syms->insert (entry (strdup ("e"), value (2.718281728459)));

  strcpy(buf, spmathpath);
  strcat(buf, "header");
  spit_file(buf);

  int err = 0;

  supress_output = 1;
  
  strcpy(buf, spmathpath);
  strcat(buf, "init.sp");

  load(new value(buf), 0, err);
  
  supress_output = 0;

  if(err) {
    sp_error("Could not load solver defaults from file \"init.sp\"\n\n");
    sp_error("using internal defaults...\n\n");

    supress_output = 1;

    sp_parse_string("slvr_solver_name = \"gmres\"");
    sp_parse_string("slvr_prec_name = \"ilut\"");
    sp_parse_string("slvr_prec_args = [3,0.0001]");
    sp_parse_string("slvr_prec_type = \"right\"");
    sp_parse_string("slvr_krylov = 10");
    sp_parse_string("slvr_maxmult = 100");
    sp_parse_string("slvr_tols = [0.000001, 0.0]");

    supress_output = 0;
  }
}

//
// sp_parse (const char *input)
//
//  Begins parsing.  If spmath is in non-windowed mode,
// then control is given over to the parser fot the rest
// of the session.  In windowed mode, this function
// simply processes one command (char *input) using the
// parser and then outputs the result, returning control
// to the calling program (in this case, the "Enter"
// key handler in spmath.tcl)
//
int sp_parse (const char *input)
{
  // Buffer to be lexed and parsed
  static char buff[BUFF_SIZE];

  // Dummy variable for lexer
  YYSTYPE dummy;

  // Main loop for command-line mode
#ifndef NO_TK_COMPILE
  if(no_tk) {
#endif
    
    // If we're in command-line mode, then parse the command
    // line until the user quits.
    
    while (1) {
      // Output the prompt
      sp_prompt();
      // Get the command
      cin.getline (buff + strlen (buff), BUFF_SIZE - strlen (buff), '\n');
      *(buff + strlen (buff) + 1) = '\0';
      *(buff + strlen (buff)) = '\n';
      str_flag = 1;
      str = buff;
      nest_count = 0;

      int l;
      // Adjust the nest count using lex
      do {
	l = yylex(&dummy);
      } while(l != '\n' && l != ERROR);
      // do nothing
      
      // Catch errors and try again
      if(l == ERROR) { 

	string t(buff);
	hist_list.put_item (t);
	hist_num ++;
	hist_cur = hist_num;
	buff[0] = '\0';
	continue;
      }

      *(buff + strlen(buff) -1) = ' ';
      
      // As long as we are in a nested construct (like a for
      // loop or a function definition) then continue to read
      // into the buffer.
      while (nest_count > 0) {
	sp_prompt();
	cin.getline (buff + strlen (buff), BUFF_SIZE - strlen (buff), '\n');
	*(buff + strlen (buff) + 1) = '\0';
	*(buff + strlen (buff)) = '\n';
	str_flag = 1;
	str = buff;
	nest_count = 0;

	// Adjust the nest count using lex
	do {
	  l = yylex(&dummy);
	} while(l != '\n' && l != ERROR);
	// do nothing
	
	// Catch errors and try again
	if(l == ERROR) { 

	  string t(buff);
	  hist_list.put_item (t);
	  hist_num ++;
	  hist_cur = hist_num;
	  buff[0] = '\0';
	  continue;
	}

	*(buff + strlen (buff) - 1) = ' ';
      }				// end while

      string t (buff);
      if (strlen (t) > 1) {
	
	// Make the last character in the buffer a flag
	// (for the parser)
	*(buff + strlen (buff) - 1) = '$';
	str_flag = 1;
	str = buff;
	
	// Reset the parser and parse all the stuff we
	// sent to the lexer
	yyrestart (yyin);
	yyparse ();
	
	// Add command to history
	hist_list.put_item (t);

	// Increment the number of items in history
	hist_num ++;
	hist_cur = hist_num;
      }				// end if
    bail:

      nest_count = 0;

      // Erase the buffer
      buff[0] = '\0';
    }				// end while

#ifndef NO_TK_COMPILE
  }

  // We're in tk mode, so we're just parsing a string
  else {

    // Stick in input string into the buffer and
    // format it for lex

    strcpy (buff + strlen (buff), input);
    *(buff + strlen (buff) + 1) = '\0';
    *(buff + strlen (buff)) = '\n';

    str_flag = 1;
    str = buff;
    nest_count = 0;
    
    int l;
    // Adjust the nest count using lex
    do {
      l = yylex(&dummy);
    } while(l != '\n' && l != ERROR);
    // do nothing
    
    // Catch errors and try again
    if(l == ERROR) { 
      
      string t(buff);
      hist_list.put_item (t);
      hist_num ++;
      hist_cur = hist_num;
      sp_out("\n");
      sp_prompt();

      // Erase the buffer
      buff[0] = '\0';
      return 0;
    }

    // Eliminate the newline character
    *(buff + strlen (buff) - 1) = ' ';
    
    if (nest_count > 0) {
      // Respond that we are waiting for additional input
      sp_prompt();
      return 1;		
    }
    
    string t (buff);
    if (strlen (t) > 1) {
      
      // Add command to history
      hist_list.put_item (t);
      
      // Make the last character in the buffer a flag
      // (for the parser)
      *(buff + strlen (buff) - 1) = '$';
      str_flag = 1;
      str = buff;
      
      // Reset the parser and parse from the string
      yyrestart (yyin);
      yyparse ();

      // Increment the number of items in history
      hist_num += 1;
      hist_cur = hist_num;
    }

    sp_out("\n");
    sp_prompt();

    // Erase the buffer
    buff[0] = '\0';
  }
#endif

  // Only tk mode will reach the end
  return 0;
}

//
// sp_parse_string(char * input)
//
//  This function is intended to be a behind-the-scenes
// helper function for quickly executing spmath commands.
// Simply pass this function the command you would like
// to execute, and it will be parsed as usual without
// outputting anything to the command line.  This fucntion
// will not handle multi-line statements with nested
// constructs.
//
// ex: sp_parse_string("pi=3.14");
//     sp_parse_string("solver_name=\"gmres\"");
//     etc...
//
int sp_parse_string(const char * input) {

  char buf[256];

  // Format string for parser
  strcpy(buf, input);
  strcat(buf, "$");

  // Set the string flag and let the string be the
  // input.
  str_flag = 1;
  str = buf;
  nest_count = 0;

  // Restart the parser and run it on the string.
  yyrestart (yyin);
  yyparse ();

  // Return success
  return 1;
}

//
// yyerror(char *err)
//
//  Overrides the default yyerror and re-routes the
// output to our more versitile function sp_error.
// It is overloaded to accept const char *'s so that
// picky compilers don't give warning messages about
// string literals being passed as char *'s.
//
int yyerror (char *err) {

  sp_error (err);
  sp_error ("\n");
  return -1;
}

int yyerror (const char *err) {

  sp_error (err);
  sp_error ("\n");
  return -1;
}

value *eval_funct (char *name, list * args, int &err) {

  // Evaluate a user defined function with the name mame and an
  // argument list args.

  syms = new symtab (syms);

  // Lookup the function and get its object
  funct_def f (*root.lookup (name).get_value ().funct);

  // Make sure the arglist has the right number of arguments
  int count = 0;
  args->init_curr_prev ();
  if (!args->empty ()) {
    count += 1;
    while (!args->end ()) {
      args->get_next ();
      count += 1;
    }				// end while
  }				// end if

  if (count != f.get_argc ()) {
    err = 1;
    sp_error("Error, function \"");
    sp_error(name);
    sp_error("\" takes ");
    sp_error(f.get_argc());
    sp_error(" argument");
    if(f.get_argc() != 1) {
      sp_error("s");
    }
    sp_error("\n");
    return new value ();
  }				// end if

  int i;
  // Add all arguments to the local symbol table
  for (i = 1; i <= f.get_argc (); i += 1) {
    syms->insert (entry (f.get_arg (i), args->pop ().get_value ()));
  }				// end for

  str_flag = 1;
  str = new char[strlen (f.get_body ()) + 1];
  strcpy (str, f.get_body ());
  strcat (str, "$");

  //  cout << "str is " << str << endl;

  // Restart the parser using the function text as the input
  yyrestart (yyin);
  yyparse ();

  value *ret;
  // Lookup the return value in the symbol table
  if (syms->contains (f.get_ret ())) {
    ret = new value (syms->lookup (f.get_ret ()).get_value ());
    // Determine the type and return the appropriate value
    if (ret->type == NUM)
      ret->num = (ret->num);
    else if (ret->type == DENSE)
      ret->dmat = new dense (*ret->dmat);
    else if (ret->type == SPARSE)
      ret->smat = new sparse (*ret->smat);
    else if (ret->type == STRING)
      ret->str = strdup (ret->str);
    else
      assert (0);		// Should never happen
  }				// end if  
  else
    // Return value was not in the symbol table
    ret = new value ();

  // Asserts that this funtion's symbol table is not the global
  // symbol table
  assert (!syms->is_root ());
  syms->remove_all ();
  symtab *temp = syms;

  // Reestablish sysms as the parent's symbol table
  syms = syms->get_parent ();
  delete temp;

  // Return the function's return value
  return ret;

}				// end  eval_funct

//
// value *load (value * file, int echo, int &err)
//
//  This function will load a file containing spmath
// commands from a file whose filename is the string
// wrapped by value * file.  It then executes these
// commands one by one and, if echo == 1, also echos
// the commands onto the command line.  It is assumed
// that each command appears on a separate line
// (with the exception of nested constructs, which
// may span several lines).
//

value *load (value * file, int echo, int &err)
{
  char buff[BUFF_SIZE];		// input buffer

  buff[0] = '\0';

  YYSTYPE dummy;
  struct stat statbuff;		// buffer to hold the status of the file

  char * filename;

  if (file->type != STRING) {
    yyerror ("Error, 1st argument of load must be a string.");
    err = 1;
    return file;
  }				// end if

  if (stat (file->str, &statbuff) != 0) {
    char second_try[128];
    sprintf(second_try, "%s/%s/%s", spmathpath, SCRIPT_DIR_NAME, file->str);

    if (stat (second_try, &statbuff) != 0) {

      yyerror ("Error, file does not exist.");
      err = 1;
      return file;
    }
    else {
      filename = second_try;
    }
  }
  else {
    filename = file->str;
  }

  ifstream iFile (filename, ios::in);

  if(echo) {
    sp_out("Executing \"");
    sp_out(filename);
    sp_out("\"...\n\n");
    sp_prompt();
  }

  while (!iFile.eof ()) {

    // Get the next line from the file and then format
    // it for the lexer

    iFile.getline (buff + strlen (buff), BUFF_SIZE - strlen (buff), '\n');
    *(buff + strlen (buff) + 1) = '\0';
    *(buff + strlen (buff)) = '\n';
    str_flag = 1;
    str = buff;
    nest_count = 0;

    // Skip blank lines and commented lines

    if(str[0] == '\n' || str[0] == '#') {

      buff[0] = '\0';
      continue;
    }

    // Lex this part (without then passing control to
    // the parser)

    int l;
    // Adjust the nest count using lex
    do {
      l = yylex(&dummy);
    } while(l != '\n' && l != ERROR);
    // do nothing

    // Catch errors and try again
    if(l == ERROR) { 
      
      buff[0] = '\0';
      continue;
    }

    *(buff + strlen (buff) - 1) = ' ';

    // If we're still in the middle of a nested construct
    // then keep lexing it until it ends

    while (nest_count > 0) {

      // Get the next line of this nested construct

      iFile.getline (buff + strlen (buff), BUFF_SIZE - strlen (buff), '\n');
      *(buff + strlen (buff) + 1) = '\0';
      *(buff + strlen (buff)) = '\n';
      str_flag = 1;
      str = buff;
      nest_count = 0;

      // Lex this part (without then passing control to
      // the parser)

      do {
	l = yylex(&dummy);
      } while(l != '\n' && l != ERROR);
      // do nothing
      
      // Catch errors and try again
      if(l == ERROR) { 
	
	buff[0] = '\0';
	continue;
      }

      *(buff + strlen (buff) - 1) = ' ';
    }				// end while

    // If echo mode is on, output the command so that
    // the user can see it (but don't add it to the
    // history)
    if(echo) {
      sp_prompt();
      sp_command(str);
      sp_out("\n");
    }

    // Now format the string for the yacc parser

    *(buff + strlen (buff) - 1) = '$';
    str_flag = 1;
    str = buff;

    // Run the yacc parser on the buffer string

    yyrestart(yyin);
    yyparse();
    buff[0] = '\0';

    // Put whitespace between outputs from the spmath
    // statements

    sp_out("\n");
  }				// end while

 bail:

  return new value ();
}				// end load

value *save (value * texte, value * filename, int &err)
{
  struct stat statbuff;		// buffer to hold the status of the file

  if (filename->type != STRING) {
    yyerror ("Error, 2nd argument of save must be a string.");
    err = 1;
    return filename;
  }				// end if

  if (stat (filename->str, &statbuff) == 0) {
    yyerror ("Error, file already exists.");
    err = 1;
    return filename;
  }				// end if

  if (texte->type != STRING) {
    yyerror ("Error, 1st argument of save must be a string.");
    err = 1;
    return texte;
  }				// end if

  char *txt = texte->str;
  //  cout << "txt: " << txt[0] << txt[1] << txt[2];
  ofstream destination (filename->str);
  if (!destination) {
    yyerror ("Error opening destination file");
    err = 1;
    return (filename);
  }
  int i = 0;
  while (txt[i] != '$') {
    destination << txt[i];
    i++;
  }


/* Why is this err? */
  return new value (err);

}				// end save

value *process_comma_list (list * set, int &err)
{
  value *val;
  int ncol = 0;
  int nrow = 0;
  int i, j;

  if (set->top ().get_value ().type == NUM) {
    ncol = 1;
    nrow = 1;
  }				// end if
  else {
    if (set->top ().get_value ().type == DENSE) {
      ncol = set->top ().get_value ().dmat->get_ncol ();
      nrow = set->top ().get_value ().dmat->get_nrow ();
    }				// end if
    else {
      if (set->top ().get_value ().type == SPARSE) {
	ncol = set->top ().get_value ().smat->get_ncol ();
	nrow = set->top ().get_value ().smat->get_nrow ();
      }				// end if
    }				// end else
  }				// end else

  set->init_curr_prev ();
  while (!set->end ()) {
    set->get_next ();
    if (set->get_current ().get_value ().type == NUM) {
      ncol += 1;
      // A number is considered a matrix of dimensions 1 x 1
      if (nrow != 1) {
	yyerror ("Error, Ilegal dimensions for matrix.");
	set->remove_all ();
	err = 1;
	return new value ((0));
      }				// end if
    }				// end if
    else {
      if (set->get_current ().get_value ().type == DENSE) {
	ncol += set->get_current ().get_value ().dmat->get_ncol ();
	if (nrow != set->get_current ().get_value ().dmat->get_nrow ()) {
	  yyerror ("Error, Ilegal dimensions for matrix.");
	  set->remove_all ();
	  err = 1;
	  return new value ((0));
	}			// end if
      }				// end if
      else {
	if (set->get_current ().get_value ().type == SPARSE) {
	  ncol += set->get_current ().get_value ().smat->get_ncol ();
	  if (nrow != set->get_current ().get_value ().smat->get_nrow ()) {
	    yyerror ("Error, Ilegal dimensions for matrix.");
	    set->remove_all ();
	    err = 1;
	    return new value ((0));
	  }			// end if
	}			// end if
      }				// end else
    }				// end else
  }				// end while


  dense *d;
  d = new dense (nrow, ncol);
  ncol = 0;
  while (!set->empty ()) {
    if (set->top ().get_value ().type == NUM) {
      ncol += 1;
      d->set_element (1, ncol, set->top ().get_value ().num);
    }				// end if
    else {
      if (set->top ().get_value ().type == DENSE) {
	for (i = 1; i <= nrow; i += 1)
	  for (j = ncol + 1;
	       j <= ncol + set->top ().get_value ().dmat->get_ncol (); j += 1)
	    d->set_element (i, j,
			    set->top ().get_value ().dmat->get_element (i,
									j -
									ncol));
	ncol += set->top ().get_value ().dmat->get_ncol ();
      }				// end if
      else {
	if (set->top ().get_value ().type == SPARSE) {
	  for (i = 1; i <= nrow; i += 1)
	    for (j = ncol + 1;
		 j <= ncol + set->top ().get_value ().smat->get_ncol ();
		 j +=
		 1) d->set_element (i, j,
				    set->top ().get_value ().smat->
				    get_element (i, j - ncol));
	  ncol += set->top ().get_value ().smat->get_ncol ();
	}			// end if
      }				// end else
    }				// end else
    set->remove_top ();
  }				// end while

  val = new value (d);
  return val;

}				// end process_comma_list



value *process_dense_row_list (list * set, int &err)
{
  value *val;
  int ncol = 0;
  int nrow = 0;
  int i, j;

  if (set->top ().get_value ().type == NUM) {
    ncol = 1;
    nrow = 1;
  }				// end if
  else {
    if (set->top ().get_value ().type == DENSE) {
      ncol = set->top ().get_value ().dmat->get_ncol ();
      nrow = set->top ().get_value ().dmat->get_nrow ();
    }				// end if
    else {
      if (set->top ().get_value ().type == SPARSE) {
	ncol = set->top ().get_value ().smat->get_ncol ();
	nrow = set->top ().get_value ().smat->get_nrow ();
      }				// end if
    }				// end else
  }				// end else

  set->init_curr_prev ();
  while (!set->end ()) {
    set->get_next ();
    if (set->get_current ().get_value ().type == NUM) {
      nrow += 1;
      if (ncol != 1) {
	yyerror ("Error, Ilegal dimensions for matrix.");
	set->remove_all ();
	err = 1;
	return new value ((0));
      }				// end if
    }				// end if
    else {
      if (set->get_current ().get_value ().type == DENSE) {
	nrow += set->get_current ().get_value ().dmat->get_nrow ();
	if (ncol != set->get_current ().get_value ().dmat->get_ncol ()) {
	  yyerror ("Error, Ilegal dimensions for matrix.");
	  set->remove_all ();
	  err = 1;
	  return new value ((0));
	}			// end if
      }				// end if
      else {
	if (set->get_current ().get_value ().type == SPARSE) {
	  nrow += set->get_current ().get_value ().smat->get_nrow ();
	  if (ncol != set->get_current ().get_value ().smat->get_ncol ()) {
	    yyerror ("Error, Ilegal dimensions for matrix.");
	    set->remove_all ();
	    err = 1;
	    return new value ((0));
	  }			// end if
	}			// end if
      }				// end else
    }				// end else
  }				// end while


  dense *d;
  d = new dense (nrow, ncol);
  nrow = 0;
  while (!set->empty ()) {
    if (set->top ().get_value ().type == NUM) {
      nrow += 1;
      d->set_element (nrow, 1, set->top ().get_value ().num);
    }				// end if
    else {
      if (set->top ().get_value ().type == DENSE) {
	for (i = 1; i <= ncol; i += 1)
	  for (j = nrow + 1;
	       j <= nrow + set->top ().get_value ().dmat->get_nrow (); j += 1)
	    d->set_element (j, i,
			    set->top ().get_value ().dmat->get_element (j -
									nrow,
									i));
	nrow += set->top ().get_value ().dmat->get_nrow ();
      }				// end if
      else {
	if (set->top ().get_value ().type == SPARSE) {
	  for (i = 1; i <= ncol; i += 1)
	    for (j = nrow + 1;
		 j <= nrow + set->top ().get_value ().smat->get_nrow ();
		 j +=
		 1) d->set_element (j, i,
				    set->top ().get_value ().smat->
				    get_element (j - nrow, i));
	  nrow += set->top ().get_value ().smat->get_nrow ();
	}			// end if
      }				// end else
    }				// end else
    set->remove_top ();
  }				// end while

  val = new value (d);
  return val;

}				// end process_dense_row_list

//
// These functions are defined to be extern "C" so that they
// can be passed to the "function" function in functions.C
// along with the regular C library trig functions (cos, sin,
// etc...)
//

extern "C" double cot (double x)
{
  return 1 / tan (x);
}

extern "C" double csc (double x)
{
  return 1 / sin (x);
}

extern "C" double sec (double x)
{
  return 1 / cos (x);
}

extern "C" double acot (double x)
{
  return atan (1 / x);
}

extern "C" double acsc (double x)
{
  return asin (1 / x);
}

extern "C" double asec (double x)
{
  return acos (1 / x);
}

extern "C" double round (double x)
{
  return double (int (x + .5));
}

extern "C" double trunc (double x)
{
  return double (int (x));
}

extern "C" double rnd (double x)
{
  // Return a random number (double) between 0 and 1
  // The variable x is just a dummy variable, so that this
  // function can be used to be applied to a dense matrix.

  static int rnd_flag = 0;
  time_t *tloc = NULL;

  // So that compilers won't complain...
  x = 0;

  // The first time this routine is executed, set the seed
  // the the current time.  This prevents the same sequence from
  // being used twice.
  if (rnd_flag == 0) {
    srand (int (time (tloc)));
    rnd_flag = 1;
  }
  return (double (rand ()) / 32767.0);

}				// end rnd


